#line 1 "binxpr.m"
struct _PRIVATE { struct _PRIVATE *isa; };
typedef struct _PRIVATE *id;
struct _SHARED {
  id isa;
  id clsSuper;
  char *clsName;
  char *clsTypes;
  short clsSizInstance;
  short clsSizDict;
  struct _SLT *clsDispTable;
  long clsStatus;
  struct modDescriptor *clsMod;
  unsigned clsVersion;
  id clsCats;
  id *clsGlbl;
};
extern id  (* _imp(id,char*))();
extern id  (* _impSuper(id,char*))();
extern struct modDescriptor  *_OBJCBIND_binxpr(void);
static char **selTransTbl;
struct _SLT {char *_cmd;id (*_imp)();};
struct modDescriptor {
  char *modName;
  char *modVersion;
  long modStatus;
  char *modMinSel;
  char *modMaxSel;
  id *modClsLst;
  short modSelRef;
  char **modSelTbl;
  struct methodDescriptor *modMapTbl;
};
extern struct modDescriptor binxpr_modDesc;

#line 1 "../../util/stdarg.h"
#include <stdarg.h>

#line 1 "../../util/stdlib.h"
#include <stdlib.h>

#line 1 "../../util/assert.h"
#include <assert.h>

#line 1 "../../util/stdio.h"
#include <stdio.h>

#line 1 "../../util/stddef.h"
#include <stddef.h>

#line 70 "../../include/objcrt/objcrt.h"
typedef char*SEL;
typedef char*STR;
typedef char BOOL;
typedef FILE*IOD;
typedef id SHR;
#line 79 "../../include/objcrt/objcrt.h"
typedef id(*IMP)();


typedef void(*ARGIMP)(id,SEL,void*);
#line 102 "../../include/objcrt/objcrt.h"
extern BOOL msgFlag;
extern FILE*msgIOD;
extern FILE*dbgIOD;
extern BOOL allocFlag;
extern BOOL dbgFlag;
extern BOOL noCacheFlag;
extern BOOL noNilRcvr;
#line 115 "../../include/objcrt/objcrt.h"
SEL selUid(STR);
STR selName(SEL);
void dbg(char*fmt,...);
void prnstack(FILE*file);
void loadobjc(void*modPtr);
void unloadobjc(void*modPtr);
#line 124 "../../include/objcrt/objcrt.h"
IMP fwdimp(id,SEL,IMP);
IMP fwdimpSuper(id,SEL,IMP);
void fwdmsg(id,SEL,void*,ARGIMP);
id selptrfwd(id,SEL,id,id,id,id);


id idincref(id obj);
id idassign(id*lhs,id rhs);
id iddecref(id obj);

extern id(*_fileIn)(FILE*);
extern BOOL(*_fileOut)(FILE*,id);
extern BOOL(*_storeOn)(STR,id);
extern id(*_readFrom)(STR);
void setfilein(id(*f)(FILE*));
void setfileout(BOOL(*f)(FILE*,id));

extern id(*_showOn)(id,unsigned);

void*OC_Malloc(size_t);
void*OC_MallocAtomic(size_t);
void*OC_Calloc(size_t);
void*OC_Realloc(void*,size_t);
void*OC_Free(void*data);
#line 1 "../../util/string.h"
#include <string.h>

#line 22 "node.h"
extern FILE*gfile;
extern int inlineno;
extern id infilename;
extern int outlineno;
extern char*outfilename;
extern int exitstatus;

void gc(char c);
void gextc(void);
void gcom(char*cm);
void gvarlist(id c,char*sp,char*iz);
void gcommalist(id c);
void gs(char*str);
void gf(char*fmt,...);
void gl(int no,char*fn);
void g_otbvars(void);
void gstderr(void);
void gnormal(void);

void warn(char*fmt,...);
void warnat(id sym,char*fmt,...);
void fatal(char*fmt,...);
void fatalat(id sym,char*fmt,...);
#line 22 "expr.h"
extern id e_nil;
extern id e_self;
extern id e_cmd;
extern id e_super;
extern id e_aFiler;
extern id e_ft_id;
#line 22 "type.h"
extern id t_unknown;
extern id t_void;
extern id t_char;
extern id t_bool;
extern id t_int;
extern id t_long;
extern id t_double;
extern id t_str;
extern id t_sel;
extern id t_id;
#line 22 "binxpr.h"
struct BinaryExpr_PRIVATE {

#line 42 "../../include/objcrt/Object.h"
id isa;
#line 46 "../../include/objcrt/Object.h"
unsigned short attr;
unsigned short objID;
#line 31 "expr.h"
id type;
#line 24 "binxpr.h"
STR op;
id lhs,rhs;};

#line 22 "binxpr.h"
extern id  BinaryExpr;

#line 22 "binxpr.h"
extern struct _SHARED _BinaryExpr;
extern struct _SHARED __BinaryExpr;


#line 33 "binxpr.m"
static id i_BinaryExpr_rhs_(struct BinaryExpr_PRIVATE *self,SEL _cmd,id aRcvr)
{self->
rhs=aRcvr;
return(id)self;
}

static id i_BinaryExpr_op_(struct BinaryExpr_PRIVATE *self,SEL _cmd,STR anop)
{self->
op=anop;
return(id)self;
}

static id i_BinaryExpr_lhs_(struct BinaryExpr_PRIVATE *self,SEL _cmd,id aRcvr)
{self->
lhs=aRcvr;
return(id)self;
}

static BOOL i_BinaryExpr_isconstexpr(struct BinaryExpr_PRIVATE *self,SEL _cmd)
{
id objcT0,objcT1;

#line 53 "binxpr.m"
return(objcT0=self->lhs,(*(BOOL(*)(id,SEL))_imp(objcT0,selTransTbl[0]))(objcT0,selTransTbl[0]))&&(objcT1=self->rhs,(*(BOOL(*)(id,SEL))_imp(objcT1,selTransTbl[0]))(objcT1,selTransTbl[0]));
}

static int i_BinaryExpr_lineno(struct BinaryExpr_PRIVATE *self,SEL _cmd)
{
id objcT2;

#line 58 "binxpr.m"
return(objcT2=self->lhs,(*(int(*)(id,SEL))_imp(objcT2,selTransTbl[1]))(objcT2,selTransTbl[1]));
}

static id i_BinaryExpr_filename(struct BinaryExpr_PRIVATE *self,SEL _cmd)
{
id objcT3;

#line 63 "binxpr.m"
return(objcT3=self->lhs,(*_imp(objcT3,selTransTbl[2]))(objcT3,selTransTbl[2]));
}

static id i_BinaryExpr_typesynth(struct BinaryExpr_PRIVATE *self,SEL _cmd)
{
id objcT4,objcT5,objcT6;
self->
#line 68 "binxpr.m"
type=(objcT4=(objcT5=self->lhs,(*_imp(objcT5,selTransTbl[3]))(objcT5,selTransTbl[3])),(*_imp(objcT4,selTransTbl[4]))(objcT4,selTransTbl[4],(objcT6=self->rhs,(*_imp(objcT6,selTransTbl[3]))(objcT6,selTransTbl[3]))));
return(id)self;
}

static id i_BinaryExpr_synth(struct BinaryExpr_PRIVATE *self,SEL _cmd)
{
id objcT7,objcT8;

#line 74 "binxpr.m"
(objcT7=self->lhs,(*_imp(objcT7,selTransTbl[5]))(objcT7,selTransTbl[5]));
(objcT8=self->rhs,(*_imp(objcT8,selTransTbl[5]))(objcT8,selTransTbl[5]));
return(id)self;
}

static id i_BinaryExpr_gen(struct BinaryExpr_PRIVATE *self,SEL _cmd)
{
id objcT9,objcT10;

#line 81 "binxpr.m"
(objcT9=self->lhs,(*_imp(objcT9,selTransTbl[6]))(objcT9,selTransTbl[6]));
gs(self->op);
(objcT10=self->rhs,(*_imp(objcT10,selTransTbl[6]))(objcT10,selTransTbl[6]));
return(id)self;
}

static id i_BinaryExpr_st80(struct BinaryExpr_PRIVATE *self,SEL _cmd)
{
id objcT11,objcT12;

#line 89 "binxpr.m"
(objcT11=self->lhs,(*_imp(objcT11,selTransTbl[7]))(objcT11,selTransTbl[7]));
gs(self->op);
(objcT12=self->rhs,(*_imp(objcT12,selTransTbl[7]))(objcT12,selTransTbl[7]));
return(id)self;
}
extern id  Object;
extern struct _SHARED _Object;
extern struct _SHARED __Object;
extern id  Expr;
extern struct _SHARED _Expr;
extern struct _SHARED __Expr;
static struct _SLT _BinaryExpr_clsDispatchTbl[] ={
{(char*)0,(id (*)())0}
};
static struct _SLT _BinaryExpr_nstDispatchTbl[] ={
{"rhs:",(id (*)())i_BinaryExpr_rhs_},
{"op:",(id (*)())i_BinaryExpr_op_},
{"lhs:",(id (*)())i_BinaryExpr_lhs_},
{"isconstexpr",(id (*)())i_BinaryExpr_isconstexpr},
{"lineno",(id (*)())i_BinaryExpr_lineno},
{"filename",(id (*)())i_BinaryExpr_filename},
{"typesynth",(id (*)())i_BinaryExpr_typesynth},
{"synth",(id (*)())i_BinaryExpr_synth},
{"gen",(id (*)())i_BinaryExpr_gen},
{"st80",(id (*)())i_BinaryExpr_st80},
{(char*)0,(id (*)())0}
};
id BinaryExpr = (id)&_BinaryExpr;
id  *OBJCCLASS_BinaryExpr(void) { return &BinaryExpr; }
struct _SHARED  _BinaryExpr = {
  (id)&__BinaryExpr,
  (id)&_Expr,
  "BinaryExpr",
  0,
  sizeof(struct BinaryExpr_PRIVATE),
  10,
  _BinaryExpr_nstDispatchTbl,
  41,
  &binxpr_modDesc,
  0,
  (id)0,
  &BinaryExpr,
};
id  OBJCCFUNC_BinaryExpr(void) { return (id)&_BinaryExpr; }
id  OBJCCSUPER_BinaryExpr(void) { return _BinaryExpr.clsSuper; }
struct _SHARED __BinaryExpr = {
  (id)&__Object,
  (id)&__Expr,
  "BinaryExpr",
  0,
  sizeof(struct _SHARED),
  0,
  _BinaryExpr_clsDispatchTbl,
  34,
  &binxpr_modDesc,
  0,
  (id)0,
  0,
};
id  OBJCMFUNC_BinaryExpr(void) { return (id)&__BinaryExpr; }
id  OBJCMSUPER_BinaryExpr(void) { return __BinaryExpr.clsSuper; }
static char *_selTransTbl[] ={
"isconstexpr",
"lineno",
"filename",
"type",
"max:",
"synth",
"gen",
"st80",
0
};
struct modDescriptor binxpr_modDesc = {
  "binxpr",
  "objc2.3.8",
  0L,
  0,
  0,
  &BinaryExpr,
  8,
  _selTransTbl,
  0
};
struct modDescriptor *_OBJCBIND_binxpr(void)
{
  selTransTbl = _selTransTbl;
  return &binxpr_modDesc;
}
int _OBJCPOSTLINK_binxpr = 1;


