#line 1 "classdef.m"
struct _PRIVATE { struct _PRIVATE *isa; };
typedef struct _PRIVATE *id;
struct _SHARED {
  id isa;
  id clsSuper;
  char *clsName;
  char *clsTypes;
  short clsSizInstance;
  short clsSizDict;
  struct _SLT *clsDispTable;
  long clsStatus;
  struct modDescriptor *clsMod;
  unsigned clsVersion;
  id clsCats;
  id *clsGlbl;
};
extern id  (* _imp(id,char*))();
extern id  (* _impSuper(id,char*))();
extern struct modDescriptor  *_OBJCBIND_classdef(void);
static char **selTransTbl;
struct _SLT {char *_cmd;id (*_imp)();};
struct modDescriptor {
  char *modName;
  char *modVersion;
  long modStatus;
  char *modMinSel;
  char *modMaxSel;
  id *modClsLst;
  short modSelRef;
  char **modSelTbl;
  struct methodDescriptor *modMapTbl;
};
extern struct modDescriptor classdef_modDesc;

#line 1 "../../util/stdarg.h"
#include <stdarg.h>

#line 1 "../../util/stdlib.h"
#include <stdlib.h>

#line 1 "../../util/assert.h"
#include <assert.h>

#line 1 "../../util/string.h"
#include <string.h>

#line 1 "../../util/stdio.h"
#include <stdio.h>

#line 1 "../../util/stddef.h"
#include <stddef.h>

#line 70 "../../include/objcrt/objcrt.h"
typedef char*SEL;
typedef char*STR;
typedef char BOOL;
typedef FILE*IOD;
typedef id SHR;
#line 79 "../../include/objcrt/objcrt.h"
typedef id(*IMP)();


typedef void(*ARGIMP)(id,SEL,void*);
#line 102 "../../include/objcrt/objcrt.h"
extern BOOL msgFlag;
extern FILE*msgIOD;
extern FILE*dbgIOD;
extern BOOL allocFlag;
extern BOOL dbgFlag;
extern BOOL noCacheFlag;
extern BOOL noNilRcvr;
#line 115 "../../include/objcrt/objcrt.h"
SEL selUid(STR);
STR selName(SEL);
void dbg(char*fmt,...);
void prnstack(FILE*file);
void loadobjc(void*modPtr);
void unloadobjc(void*modPtr);
#line 124 "../../include/objcrt/objcrt.h"
IMP fwdimp(id,SEL,IMP);
IMP fwdimpSuper(id,SEL,IMP);
void fwdmsg(id,SEL,void*,ARGIMP);
id selptrfwd(id,SEL,id,id,id,id);


id idincref(id obj);
id idassign(id*lhs,id rhs);
id iddecref(id obj);

extern id(*_fileIn)(FILE*);
extern BOOL(*_fileOut)(FILE*,id);
extern BOOL(*_storeOn)(STR,id);
extern id(*_readFrom)(STR);
void setfilein(id(*f)(FILE*));
void setfileout(BOOL(*f)(FILE*,id));

extern id(*_showOn)(id,unsigned);

void*OC_Malloc(size_t);
void*OC_MallocAtomic(size_t);
void*OC_Calloc(size_t);
void*OC_Realloc(void*,size_t);
void*OC_Free(void*data);
#line 1 "../../util/string.h"
#include <string.h>

#line 1 "../../util/stdio.h"
#include <stdio.h>

#line 32 "../../include/objpak/ocstring.h"
typedef struct objstr{
int count;
int capacity;
char*ptr;
}*objstr_t;
#line 31 "../../include/objpak/ordcltn.h"
typedef struct objcol{
int count;
int capacity;
id*ptr;
}*objcol_t;
#line 28 "../../include/objpak/set.h"
typedef struct objset{
int count;
int capacity;
id*ptr;
}*objset_t;
#line 22 "node.h"
extern FILE*gfile;
extern int inlineno;
extern id infilename;
extern int outlineno;
extern char*outfilename;
extern int exitstatus;

void gc(char c);
void gextc(void);
void gcom(char*cm);
void gvarlist(id c,char*sp,char*iz);
void gcommalist(id c);
void gs(char*str);
void gf(char*fmt,...);
void gl(int no,char*fn);
void g_otbvars(void);
void gstderr(void);
void gnormal(void);

void warn(char*fmt,...);
void warnat(id sym,char*fmt,...);
void fatal(char*fmt,...);
void fatalat(id sym,char*fmt,...);
#line 22 "symbol.h"
extern id s_void;
extern id s_char;
extern id s_bool;
extern id s_int;
extern id s_long;
extern id s_double;
extern id s_str;
extern id s_sel;
extern id s_newblock;
extern id s_main;
extern id s_objcmain;
extern id s_id;
extern id s_nil;
extern id s_self;
extern id s_cmd;
extern id s_super;
extern id s_type;
extern id s_aFiler;
extern id s_fileIn;
extern id s_fileOut;
extern id s_fileInIdsFrom;
extern id s_fileOutIdsFor;
extern id s_returnval;
extern id s_returnflag;
extern id s_increfs;
extern id s_decrefs;
extern id s_idincref;
extern id s_iddecref;

BOOL istypeword(id sym);
BOOL isbuiltinfun(id sym);
int pragmatoggle(char*s);
void definebuiltintype(char*s);
void definebuiltinfun(char*s);
void definebuiltinvar(char*s);
#line 22 "classdef.h"
extern id curclassdef;
extern id curstruct;
#line 22 "trlunit.h"
extern id trlunit;
#line 22 "options.h"
void defoptions(void);

extern int o_gnu;
extern int o_refcnt;
extern int o_ppi;
extern int o_watcom;
extern int o_ibmvac;
extern int o_msdos;
extern int o_enableasm;
extern int o_nolinetags;
extern int o_buffered;
extern int o_quiet;
extern int o_outputcode;
extern int o_version;
extern int o_otb;
extern int o_llkeyw;
extern int o_comments;
extern int o_seltranslation;
extern int o_categories;
extern int o_blocks;
extern int o_fwd;
extern int o_selptr;
extern int o_cache;
extern int o_filer;
extern int o_selfassign;
extern char*o_bind;
extern int o_refbind;
extern int o_inlinecache;
extern int o_cplus;
extern int o_gencode;
extern int o_st80;
extern int o_selfassign;
extern int o_nilrcvr;
extern int o_shareddata;
extern int o_oneperfile;
extern int o_cvars;
extern int o_warnlex;
extern int o_warnfwd;
extern int o_warnsuggest;
extern int o_warnintvar;
extern int o_warnclasstype;
extern int o_warntypeconflict;
extern int o_warnundefined;
extern int o_warnlocalnst;
extern int o_warnnotfound;
extern int o_warnmissingmethods;
extern int o_postlink;
extern char*o_infile;
extern char*o_outfile;
extern char*o_srcfilename;
extern char*o_initcall;
extern char*o_tagformat;
extern char*o_mainfun;
extern char*o_pathsep;
extern int o_debuginfo;
extern int o_checkbind;
extern int o_linemax;
extern int o_structassign;
#line 22 "def.h"
extern id curdef;
#line 22 "type.h"
extern id t_unknown;
extern id t_void;
extern id t_char;
extern id t_bool;
extern id t_int;
extern id t_long;
extern id t_double;
extern id t_str;
extern id t_sel;
extern id t_id;
#line 23 "util.h"
extern FILE*yyin;
extern int yyparse();

FILE*openfile(STR name,STR modfs);
FILE*reopenfile(STR name,STR modfs,FILE*of);

extern int okblock;

id mkcppdirect(char*s);
id mkexprstmt(id expr);
id mklabeledstmt(id label,id stmt);
id mkcasestmt(id keyw,id expr,id stmt);
id mkdefaultstmt(id keyw,id stmt);
id mkifstmt(id keyw,id expr,id stmt);
id mkifelsestmt(id keyw,id expr,id stmt,id ekeyw,id estmt);
id mkswitchstmt(id keyw,id expr,id stmt);
id mkwhilestmt(id keyw,id expr,id stmt);
id mkdostmt(id keyw,id stmt,id wkeyw,id expr);
id mkforstmt(id keyw,id a,id b,id c,id stmt);
id mkgotostmt(id keyw,id label);
id mkcontinuestmt(id keyw);
id mkbreakstmt(id keyw);
id mkreturnstmt(id keyw,id expr);
id mkcastexpr(id a,id b);
id mkcondexpr(id a,id b,id c);
id mkunaryexpr(STR op,id a);
id mksizeof(id a);
id mkaddressof(id a);
id mkdereference(id a);
id mkbinexpr(id a,STR op,id b);
id mkcommaexpr(id a,id b);
id mkrelexpr(id a,STR op,id b);
id mkassignexpr(id a,STR op,id b);
id mkfuncall(id funname,id args);
id mkbuiltincall(id funname,id args);
id mkfunbody(id datadefs,id compound);
void declarefun(id specs,id decl);
void declaremeth(BOOL factory,id decl);
id mkfundef(id specs,id decl,id body);
id mkmethdef(BOOL factory,id decl,id body);
id mkmesgexpr(id receiver,id args);
id mkdecl(id ident);
id mkprecdecl(id tquals,id decl);
id mkarraydecl(id lhs,id ix);
id mkfundecl(id lhs,id args);
id mkprefixdecl(id lhs,id rhs);
id mkpostfixdecl(id lhs,id rhs);
id mkpointer(id specs,id pointer);
id mkbitfielddecl(id decl,id expr);
id mkstardecl(id pointer,id decl);
id mkasmop(id string,id expr);
id mkasmstmt(id keyw,id tqual,id expr,id asmop1,id asmop2,id clobbers);
id mkcompstmt(id lb,id datadefs,id stmtlist,id rb);
id mklist(id c,id s);
id mklist2(id c,id s,id t);
id atdefsaddall(id c,id n);
id mkblockexpr(id lb,id parms,id datadefs,id stmts,id expr,id rb);
id mkclassdef(id keyw,id name,id sname,id ivars,id cvars);
id mkdatadef(id datadef,id specs,id decl,id initializer);
id mkencodeexpr(id name);
id mkenumspec(id keyw,id name,id lb,id list,id rb);
id mkenumerator(id name,id value);
id mkgnuattrib(id anyword,id exprlist);
id mkgnuattribdecl(id keyw,id list);
id mklistexpr(id lb,id x,id rb);
id mktypename(id specs,id decl);
id mkcomponentdef(id cdef,id specs,id decl);
id mkstructspec(id keyw,id name,id lb,id defs,id rb);
id mkkeywarg(id sel,id arg);
id mkkeywdecl(id sel,id cast,id arg);
id mkmethproto(id cast,id usel,id ksel,BOOL varargs);
id mkidentexpr(id name);
id mkconstexpr(id name,id schain);
id mkprecexpr(id expr);
id mkarrowexpr(id array,id ix);
id mkdotexpr(id array,id ix);
id mkindexexpr(id array,id ix);
id mkpostfixexpr(id expr,id pf);
id mkparmdef(id parmdef,id specs,id decl);
id mkparmdeflist(id idents,id parmdefs,BOOL varargs);
id mkselarg(id selarg,id usel,int ncols);
id mkselectorexpr(id expr);

void procextdef(id def);
void finclassdef(void);
void datadefokblock(id datadef,id specs,id decl);

id mkfileinmeth(id classdef,id ivarnames,id ivartypes);
id mkfileoutmeth(id classdef,id ivarnames,id ivartypes);

id mkincrefsmeth(id classdef,id ivarnames,id ivartypes);
id mkdecrefsmeth(id classdef,id ivarnames,id ivartypes);
#line 44 "classdef.m"
id curclassdef;
#line 25 "classdef.h"
struct ClassDef_PRIVATE {

#line 42 "../../include/objcrt/Object.h"
id isa;
#line 46 "../../include/objcrt/Object.h"
unsigned short attr;
unsigned short objID;
#line 27 "classdef.h"
id selftype;
id classname;
char*otbtypename;
char*privtypename;
char*shartypename;
char*clsdisptblname;
char*nstdisptblname;
char*globfunname;
char*_classname;
char*_classfunname;
char*_superfunname;
char*_m_classname;
char*_m_classfunname;
char*_m_superfunname;
id rootc;
id superc;
id supername;
id ivars,cvars;
BOOL emitintf;
BOOL emitimpl;
BOOL emitfwddecl;
BOOL isimpl;
BOOL iscategory;
id clsdispsels,nstdispsels;
id clsdisptbl;
id nstdisptbl;
id clssels;
id nstsels;
id compdic,compnames,comptypes;
id ivardic,ivarnames,ivartypes;
id cvardic,cvarnames,cvartypes;
id allivarnames,allcvarnames;
id fileinmethod,fileoutmethod;
id decrefsmethod,increfsmethod;};

#line 25 "classdef.h"
extern id  ClassDef;

#line 25 "classdef.h"
extern struct _SHARED _ClassDef;
extern struct _SHARED __ClassDef;


#line 48 "classdef.m"
static char*i_ClassDef_privtypename(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->privtypename;
}

#line 33 "type.h"
extern id  Type;

#line 58 "symbol.h"
extern id  Symbol;

#line 22 "pointer.h"
extern id  Pointer;

#line 53 "classdef.m"
static id i_ClassDef_selftype(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if( !self->selftype){
id objcT0,objcT1,objcT2,objcT3,objcT4;
(
#line 56 "classdef.m"
void)0;self->
selftype=(objcT0=Type,(*_imp(objcT0,selTransTbl[0]))(objcT0,selTransTbl[0]));
(objcT1=self->selftype,(*_imp(objcT1,selTransTbl[1]))(objcT1,selTransTbl[1],(objcT2=Symbol,(*(id(*)(id,SEL,STR,...))_imp(objcT2,selTransTbl[2]))(objcT2,selTransTbl[2],"struct %s",self->privtypename))));
(objcT3=self->selftype,(*_imp(objcT3,selTransTbl[3]))(objcT3,selTransTbl[3],(objcT4=Pointer,(*_imp(objcT4,selTransTbl[0]))(objcT4,selTransTbl[0]))));
}
return self->selftype;
}

static char*i_ClassDef_shartypename(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->shartypename;
}

static char*i_ClassDef_otbtypename(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->otbtypename;
}

static id i_ClassDef_shartypename_(struct ClassDef_PRIVATE *self,SEL _cmd,char*s)
{self->

shartypename=s;
return(id)self;
}

static id c_ClassDef_new(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT5,objcT6;

#line 83 "classdef.m"
return(objcT5=(objcT6=__ClassDef.clsSuper,(*_impSuper(objcT6,selTransTbl[0]))((id)self,selTransTbl[0])),(*(id(*)(id,SEL,char*))_imp(objcT5,selTransTbl[4]))(objcT5,selTransTbl[4],"_SHARED"));
}

static id i_ClassDef_warnpending(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT7;

#line 88 "classdef.m"
warn("definition of %s not properly ended.",(objcT7=(id)self,(*(char*(*)(id,SEL))_imp(objcT7,selTransTbl[5]))(objcT7,selTransTbl[5])));
return(id)self;
}

#line 38 "../../include/objpak/ocstring.h"
extern id  String;

#line 92 "classdef.m"
static id i_ClassDef_classname_(struct ClassDef_PRIVATE *self,SEL _cmd,id sym)
{
id objcT8,objcT9,objcT16,objcT17,objcT18;
id objcT19,objcT20,objcT21,objcT22,objcT23;
id objcT24,objcT25,objcT26,objcT27,objcT28;
id objcT29;

#line 94 "classdef.m"
char*s;(

void)0;self->
classname=sym;
s=(objcT8=self->classname,(*(STR(*)(id,SEL))_imp(objcT8,selTransTbl[6]))(objcT8,selTransTbl[6]));
(objcT9=trlunit,(*_imp(objcT9,selTransTbl[7]))(objcT9,selTransTbl[7],sym,(id)self));

if(o_oneperfile){self->
privtypename="_PRIVATE";self->
clsdisptblname="_clsDispatchTbl";self->
nstdisptblname="_nstDispatchTbl";
}else{
id objcT10,objcT11,objcT12,objcT13,objcT14;
id objcT15;
self->
#line 106 "classdef.m"
privtypename=(objcT10=(objcT11=String,(*(id(*)(id,SEL,STR,...))_imp(objcT11,selTransTbl[2]))(objcT11,selTransTbl[2],"%s_PRIVATE",s)),(*(STR(*)(id,SEL))_imp(objcT10,selTransTbl[8]))(objcT10,selTransTbl[8]));self->
clsdisptblname=(objcT12=(objcT13=String,(*(id(*)(id,SEL,STR,...))_imp(objcT13,selTransTbl[2]))(objcT13,selTransTbl[2],"_%s_clsDispatchTbl",s)),(*(STR(*)(id,SEL))_imp(objcT12,selTransTbl[8]))(objcT12,selTransTbl[8]));self->
nstdisptblname=(objcT14=(objcT15=String,(*(id(*)(id,SEL,STR,...))_imp(objcT15,selTransTbl[2]))(objcT15,selTransTbl[2],"_%s_nstDispatchTbl",s)),(*(STR(*)(id,SEL))_imp(objcT14,selTransTbl[8]))(objcT14,selTransTbl[8]));
}self->
globfunname=(objcT16=(objcT17=String,(*(id(*)(id,SEL,STR,...))_imp(objcT17,selTransTbl[2]))(objcT17,selTransTbl[2],"OBJCCLASS_%s",s)),(*(STR(*)(id,SEL))_imp(objcT16,selTransTbl[8]))(objcT16,selTransTbl[8]));self->
_classfunname=(objcT18=(objcT19=String,(*(id(*)(id,SEL,STR,...))_imp(objcT19,selTransTbl[2]))(objcT19,selTransTbl[2],"OBJCCFUNC_%s",s)),(*(STR(*)(id,SEL))_imp(objcT18,selTransTbl[8]))(objcT18,selTransTbl[8]));self->
_superfunname=(objcT20=(objcT21=String,(*(id(*)(id,SEL,STR,...))_imp(objcT21,selTransTbl[2]))(objcT21,selTransTbl[2],"OBJCCSUPER_%s",s)),(*(STR(*)(id,SEL))_imp(objcT20,selTransTbl[8]))(objcT20,selTransTbl[8]));self->
_m_classfunname=(objcT22=(objcT23=String,(*(id(*)(id,SEL,STR,...))_imp(objcT23,selTransTbl[2]))(objcT23,selTransTbl[2],"OBJCMFUNC_%s",s)),(*(STR(*)(id,SEL))_imp(objcT22,selTransTbl[8]))(objcT22,selTransTbl[8]));self->
_m_superfunname=(objcT24=(objcT25=String,(*(id(*)(id,SEL,STR,...))_imp(objcT25,selTransTbl[2]))(objcT25,selTransTbl[2],"OBJCMSUPER_%s",s)),(*(STR(*)(id,SEL))_imp(objcT24,selTransTbl[8]))(objcT24,selTransTbl[8]));self->
_classname=(objcT26=(objcT27=String,(*(id(*)(id,SEL,STR,...))_imp(objcT27,selTransTbl[2]))(objcT27,selTransTbl[2],"_%s",s)),(*(STR(*)(id,SEL))_imp(objcT26,selTransTbl[8]))(objcT26,selTransTbl[8]));self->
_m_classname=(objcT28=(objcT29=String,(*(id(*)(id,SEL,STR,...))_imp(objcT29,selTransTbl[2]))(objcT29,selTransTbl[2],"__%s",s)),(*(STR(*)(id,SEL))_imp(objcT28,selTransTbl[8]))(objcT28,selTransTbl[8]));
if(o_otb){
id objcT30,objcT31;
self->
#line 118 "classdef.m"
otbtypename=(objcT30=(objcT31=String,(*(id(*)(id,SEL,STR,...))_imp(objcT31,selTransTbl[2]))(objcT31,selTransTbl[2],"%s_OTB",s)),(*(STR(*)(id,SEL))_imp(objcT30,selTransTbl[8]))(objcT30,selTransTbl[8]));
}
return(id)self;
}

static id i_ClassDef_checksupername_(struct ClassDef_PRIVATE *self,SEL _cmd,id sym)
{
id objcT32,objcT34,objcT35,objcT36;

#line 125 "classdef.m"
char*m="conflicting superclasses %s and %s for %s.";
char*n="conflicting superclass declarations for %s.";

if(sym==(id)0&&self->supername==(id)0)
return(id)self;
if(sym!=(id)0&&self->supername!=(id)0&&(objcT32=self->supername,(*(BOOL(*)(id,SEL,id))_imp(objcT32,selTransTbl[9]))(objcT32,selTransTbl[9],sym)))
return(id)self;
if(sym==(id)0||self->supername==(id)0){
id objcT33;

#line 133 "classdef.m"
fatal(n,(objcT33=(id)self,(*(char*(*)(id,SEL))_imp(objcT33,selTransTbl[5]))(objcT33,selTransTbl[5])));
return(id)self;
}
fatalat(sym,m,(objcT34=sym,(*(STR(*)(id,SEL))_imp(objcT34,selTransTbl[6]))(objcT34,selTransTbl[6])),(objcT35=self->supername,(*(STR(*)(id,SEL))_imp(objcT35,selTransTbl[6]))(objcT35,selTransTbl[6])),(objcT36=(id)self,(*(char*(*)(id,SEL))_imp(objcT36,selTransTbl[5]))(objcT36,selTransTbl[5])));
return(id)self;
}

static id i_ClassDef_supername_(struct ClassDef_PRIVATE *self,SEL _cmd,id sym)
{
id objcT37;
self->
#line 142 "classdef.m"
supername=sym;
if(sym!=(id)0&&((self->superc=(objcT37=trlunit,(*_imp(objcT37,selTransTbl[10]))(objcT37,selTransTbl[10],sym)))==(id)0)){
id objcT38,objcT39;

#line 144 "classdef.m"
fatal("cannot find %s superclass of %s",(objcT38=sym,(*(STR(*)(id,SEL))_imp(objcT38,selTransTbl[6]))(objcT38,selTransTbl[6])),(objcT39=(id)self,(*(char*(*)(id,SEL))_imp(objcT39,selTransTbl[5]))(objcT39,selTransTbl[5])));
}
return(id)self;
}

static char*i_ClassDef_classname(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT40;

#line 151 "classdef.m"
return(objcT40=self->classname,(*(STR(*)(id,SEL))_imp(objcT40,selTransTbl[6]))(objcT40,selTransTbl[6]));
}

static char*i_ClassDef_globfunname(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->globfunname;
}

static char*i_ClassDef__classname(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->_classname;
}

static char*i_ClassDef__m_classname(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->_m_classname;
}

static char*i_ClassDef__classfunname(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->_classfunname;
}

static char*i_ClassDef__m_classfunname(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->_m_classfunname;
}

static char*i_ClassDef__superfunname(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->_superfunname;
}

static char*i_ClassDef__m_superfunname(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->_m_superfunname;
}

static char*i_ClassDef_supername(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT41;

#line 191 "classdef.m"
return(self->supername)?(objcT41=self->supername,(*(STR(*)(id,SEL))_imp(objcT41,selTransTbl[6]))(objcT41,selTransTbl[6])):NULL;
}

static id i_ClassDef_superclassdef(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->superc;
}

static id i_ClassDef_rootclassdef(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if( !self->rootc){
id objcT42;

#line 202 "classdef.m"
id p,q;

p=(id)self;
while((q=(objcT42=p,(*_imp(objcT42,selTransTbl[11]))(objcT42,selTransTbl[11])))){
p=q;
}self->
rootc=p;
}
return self->rootc;
}

static char*i_ClassDef_rootname(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT43,objcT44;

#line 215 "classdef.m"
return(objcT43=(objcT44=(id)self,(*_imp(objcT44,selTransTbl[12]))(objcT44,selTransTbl[12])),(*(char*(*)(id,SEL))_imp(objcT43,selTransTbl[5]))(objcT43,selTransTbl[5]));
}

static int i_ClassDef_numidivars(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT45;

#line 220 "classdef.m"
int i,n;
int count=0;

if(self->ivars)
for(i=0,n=(objcT45=self->ivars,(*(unsigned(*)(id,SEL))_imp(objcT45,selTransTbl[13]))(objcT45,selTransTbl[13]));i<n;i++){
id objcT46,objcT47;

#line 225 "classdef.m"
if((objcT46=(objcT47=self->ivartypes,(*(id(*)(id,SEL,unsigned))_imp(objcT47,selTransTbl[14]))(objcT47,selTransTbl[14],i)),(*(BOOL(*)(id,SEL))_imp(objcT46,selTransTbl[15]))(objcT46,selTransTbl[15])))
count++;
}
return count;
}

static id i_ClassDef_synthrefcntmethods(struct ClassDef_PRIVATE *self,SEL _cmd)
{(

void)0;
o_refcnt=0;

if(self->isimpl){
id objcT48,objcT50;

#line 238 "classdef.m"
if( !self->nstdisptbl|| !(objcT48=self->nstdispsels,(*_imp(objcT48,selTransTbl[16]))(objcT48,selTransTbl[16],s_decrefs))){
id objcT49;
self->
#line 239 "classdef.m"
decrefsmethod=mkdecrefsmeth(curclassdef,self->ivarnames,self->ivartypes);
(objcT49=self->decrefsmethod,(*_imp(objcT49,selTransTbl[17]))(objcT49,selTransTbl[17]));
}
if( !self->nstdisptbl|| !(objcT50=self->nstdispsels,(*_imp(objcT50,selTransTbl[16]))(objcT50,selTransTbl[16],s_increfs))){
id objcT51;
self->
#line 243 "classdef.m"
increfsmethod=mkincrefsmeth(curclassdef,self->ivarnames,self->ivartypes);
(objcT51=self->increfsmethod,(*_imp(objcT51,selTransTbl[17]))(objcT51,selTransTbl[17]));
}
}
o_refcnt++;
return(id)self;
}

static id i_ClassDef_synthfilermethods(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if(self->isimpl){
id objcT52,objcT54;

#line 254 "classdef.m"
if( !self->nstdisptbl|| !(objcT52=self->nstdispsels,(*_imp(objcT52,selTransTbl[16]))(objcT52,selTransTbl[16],s_fileInIdsFrom))){
id objcT53;
self->
#line 255 "classdef.m"
fileinmethod=mkfileinmeth(curclassdef,self->ivarnames,self->ivartypes);
(objcT53=self->fileinmethod,(*_imp(objcT53,selTransTbl[17]))(objcT53,selTransTbl[17]));
}
if( !self->nstdisptbl|| !(objcT54=self->nstdispsels,(*_imp(objcT54,selTransTbl[16]))(objcT54,selTransTbl[16],s_fileOutIdsFor))){
id objcT55;
self->
#line 259 "classdef.m"
fileoutmethod=mkfileoutmeth(curclassdef,self->ivarnames,self->ivartypes);
(objcT55=self->fileoutmethod,(*_imp(objcT55,selTransTbl[17]))(objcT55,selTransTbl[17]));
}
}
return(id)self;
}

static id i_ClassDef_ivars(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->ivars;
}

static id i_ClassDef_ivars_(struct ClassDef_PRIVATE *self,SEL _cmd,id aList)
{self->
ivars=aList;
return(id)self;
}

static id i_ClassDef_cvars(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->cvars;
}

static id i_ClassDef_cvars_(struct ClassDef_PRIVATE *self,SEL _cmd,id aList)
{
if( !o_cvars)
fatal("class variables not allowed");self->
cvars=aList;
return(id)self;
}

static id i_ClassDef_checkvars____(struct ClassDef_PRIVATE *self,SEL _cmd,char*what,id names,id types,id aList)
{
if( !names){
id objcT56;

#line 293 "classdef.m"
char*me=(objcT56=(id)self,(*(char*(*)(id,SEL))_imp(objcT56,selTransTbl[5]))(objcT56,selTransTbl[5]));

fatal("'%s' was previously declared without %s variables",me,what);
}else{
id objcT57,objcT58,objcT72,objcT74;

#line 297 "classdef.m"
int i,n;

curstruct=(id)self;(
void)0;
(objcT57=aList,(*(id(*)(id,SEL,SEL))_imp(objcT57,selTransTbl[18]))(objcT57,selTransTbl[18],selTransTbl[17]));(
void)0;
curstruct=(id)0;
for(i=0,n=(objcT58=self->compnames,(*(unsigned(*)(id,SEL))_imp(objcT58,selTransTbl[13]))(objcT58,selTransTbl[13]));i<n;i++){
id objcT59;

#line 305 "classdef.m"
if(i<(objcT59=names,(*(unsigned(*)(id,SEL))_imp(objcT59,selTransTbl[13]))(objcT59,selTransTbl[13]))){
id objcT60,objcT61,objcT62,objcT63,objcT64;
id objcT65;

#line 306 "classdef.m"
id a=(objcT60=self->compnames,(*(id(*)(id,SEL,unsigned))_imp(objcT60,selTransTbl[14]))(objcT60,selTransTbl[14],i));
id b=(objcT61=self->comptypes,(*(id(*)(id,SEL,unsigned))_imp(objcT61,selTransTbl[14]))(objcT61,selTransTbl[14],i));


if( !(objcT62=a,(*(BOOL(*)(id,SEL,id))_imp(objcT62,selTransTbl[9]))(objcT62,selTransTbl[9],(objcT63=names,(*(id(*)(id,SEL,unsigned))_imp(objcT63,selTransTbl[14]))(objcT63,selTransTbl[14],i))))|| !(objcT64=b,(*(BOOL(*)(id,SEL,id))_imp(objcT64,selTransTbl[9]))(objcT64,selTransTbl[9],(objcT65=types,(*(id(*)(id,SEL,unsigned))_imp(objcT65,selTransTbl[14]))(objcT65,selTransTbl[14],i))))){
id objcT66,objcT67,objcT68,objcT69,objcT70;
id objcT71;

#line 311 "classdef.m"
int no=(objcT66=(objcT67=names,(*(id(*)(id,SEL,unsigned))_imp(objcT67,selTransTbl[14]))(objcT67,selTransTbl[14],i)),(*(int(*)(id,SEL))_imp(objcT66,selTransTbl[19]))(objcT66,selTransTbl[19]));
char*fn=(objcT68=(objcT69=(objcT70=names,(*(id(*)(id,SEL,unsigned))_imp(objcT70,selTransTbl[14]))(objcT70,selTransTbl[14],i)),(*_imp(objcT69,selTransTbl[20]))(objcT69,selTransTbl[20])),(*(STR(*)(id,SEL))_imp(objcT68,selTransTbl[6]))(objcT68,selTransTbl[6]));
char*msg="%s variable '%s' conflicts with definition at %s:%d";

fatalat(a,msg,what,(objcT71=a,(*(STR(*)(id,SEL))_imp(objcT71,selTransTbl[6]))(objcT71,selTransTbl[6])),fn,no);
}
}
}
if(n!=(objcT72=names,(*(unsigned(*)(id,SEL))_imp(objcT72,selTransTbl[13]))(objcT72,selTransTbl[13]))){
id objcT73;

#line 320 "classdef.m"
char*me=(objcT73=(id)self,(*(char*(*)(id,SEL))_imp(objcT73,selTransTbl[5]))(objcT73,selTransTbl[5]));

fatal("list of %s variables doesn't match '%s' interface",what,me);
}
(objcT74=(id)self,(*_imp(objcT74,selTransTbl[21]))(objcT74,selTransTbl[21]));
}
return(id)self;
}

static id i_ClassDef_checkivars_(struct ClassDef_PRIVATE *self,SEL _cmd,id aList)
{
id objcT75;

#line 331 "classdef.m"
return(objcT75=(id)self,(*(id(*)(id,SEL,char*,id,id,id))_imp(objcT75,selTransTbl[22]))(objcT75,selTransTbl[22],"instance",self->ivarnames,self->ivartypes,aList));
}

static id i_ClassDef_checkcvars_(struct ClassDef_PRIVATE *self,SEL _cmd,id aList)
{
id objcT76;

#line 336 "classdef.m"
return(objcT76=(id)self,(*(id(*)(id,SEL,char*,id,id,id))_imp(objcT76,selTransTbl[22]))(objcT76,selTransTbl[22],"class",self->cvarnames,self->cvartypes,aList));
}

#line 37 "../../include/objpak/ordcltn.h"
extern id  OrdCltn;

#line 34 "../../include/objpak/set.h"
extern id  Set;

#line 339 "classdef.m"
static id i_ClassDef_addclsdisp_(struct ClassDef_PRIVATE *self,SEL _cmd,id method)
{
id objcT79,objcT80,objcT81;

#line 341 "classdef.m"
if( !self->clsdisptbl){
id objcT77,objcT78;
self->
#line 342 "classdef.m"
clsdisptbl=(objcT77=OrdCltn,(*_imp(objcT77,selTransTbl[0]))(objcT77,selTransTbl[0]));self->
clsdispsels=(objcT78=Set,(*_imp(objcT78,selTransTbl[0]))(objcT78,selTransTbl[0]));
}(
void)0;
(objcT79=self->clsdisptbl,(*_imp(objcT79,selTransTbl[23]))(objcT79,selTransTbl[23],method));
(objcT80=self->clsdispsels,(*_imp(objcT80,selTransTbl[23]))(objcT80,selTransTbl[23],(objcT81=method,(*_imp(objcT81,selTransTbl[24]))(objcT81,selTransTbl[24]))));
return(id)self;
}

static id i_ClassDef_addclssel_(struct ClassDef_PRIVATE *self,SEL _cmd,id method)
{
id objcT82,objcT83;

#line 353 "classdef.m"
if( !self->clssels)self->
clssels=(objcT82=OrdCltn,(*_imp(objcT82,selTransTbl[0]))(objcT82,selTransTbl[0]));
(objcT83=self->clssels,(*_imp(objcT83,selTransTbl[23]))(objcT83,selTransTbl[23],method));(
void)0;
return(id)self;
}

static id i_ClassDef_addnstdisp_(struct ClassDef_PRIVATE *self,SEL _cmd,id method)
{
id objcT86,objcT87,objcT88;

#line 362 "classdef.m"
if( !self->nstdisptbl){
id objcT84,objcT85;
self->
#line 363 "classdef.m"
nstdisptbl=(objcT84=OrdCltn,(*_imp(objcT84,selTransTbl[0]))(objcT84,selTransTbl[0]));self->
nstdispsels=(objcT85=Set,(*_imp(objcT85,selTransTbl[0]))(objcT85,selTransTbl[0]));
}(
void)0;
(objcT86=self->nstdisptbl,(*_imp(objcT86,selTransTbl[23]))(objcT86,selTransTbl[23],method));
(objcT87=self->nstdispsels,(*_imp(objcT87,selTransTbl[23]))(objcT87,selTransTbl[23],(objcT88=method,(*_imp(objcT88,selTransTbl[24]))(objcT88,selTransTbl[24]))));
return(id)self;
}

static id i_ClassDef_addnstsel_(struct ClassDef_PRIVATE *self,SEL _cmd,id method)
{
id objcT89,objcT90;

#line 374 "classdef.m"
if( !self->nstsels)self->
nstsels=(objcT89=OrdCltn,(*_imp(objcT89,selTransTbl[0]))(objcT89,selTransTbl[0]));
(objcT90=self->nstsels,(*_imp(objcT90,selTransTbl[23]))(objcT90,selTransTbl[23],method));(
void)0;
return(id)self;
}

static id i_ClassDef_check_includedin_factory_(struct ClassDef_PRIVATE *self,SEL _cmd,id sels,id impls,BOOL f)
{
id objcT91;

#line 383 "classdef.m"
int i,n;

for(i=0,n=(objcT91=sels,(*(unsigned(*)(id,SEL))_imp(objcT91,selTransTbl[13]))(objcT91,selTransTbl[13]));i<n;i++){
id objcT92,objcT93;

#line 386 "classdef.m"
id t=(objcT92=sels,(*(id(*)(id,SEL,unsigned))_imp(objcT92,selTransTbl[14]))(objcT92,selTransTbl[14],i));

if( !(objcT93=impls,(*(BOOL(*)(id,SEL,id))_imp(objcT93,selTransTbl[25]))(objcT93,selTransTbl[25],t))){
id objcT94;

#line 389 "classdef.m"
warn("can't find implementation of %s%s",(f)?"+":"-",(objcT94=t,(*(STR(*)(id,SEL))_imp(objcT94,selTransTbl[6]))(objcT94,selTransTbl[6])));
}
}
return(id)self;
}

static id i_ClassDef_warnimplnotfound(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT95,objcT96;

#line 397 "classdef.m"
(objcT95=(id)self,(*(id(*)(id,SEL,id,id,BOOL))_imp(objcT95,selTransTbl[26]))(objcT95,selTransTbl[26],self->clssels,self->clsdispsels,(BOOL)1));
(objcT96=(id)self,(*(id(*)(id,SEL,id,id,BOOL))_imp(objcT96,selTransTbl[26]))(objcT96,selTransTbl[26],self->nstsels,self->nstdispsels,(BOOL)0));
return(id)self;
}

static id i_ClassDef_undefcomps(struct ClassDef_PRIVATE *self,SEL _cmd)
{self->
compdic=(id)0;self->
compnames=(id)0;self->
comptypes=(id)0;
return(id)self;
}

static id i_ClassDef_defivars(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT97;
self->
#line 412 "classdef.m"
ivardic=self->compdic;self->
ivarnames=self->compnames;self->
ivartypes=self->comptypes;
return(objcT97=(id)self,(*_imp(objcT97,selTransTbl[21]))(objcT97,selTransTbl[21]));
}

static id i_ClassDef_defcvars(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT98;
self->
#line 420 "classdef.m"
cvardic=self->compdic;self->
cvarnames=self->compnames;self->
cvartypes=self->comptypes;
return(objcT98=(id)self,(*_imp(objcT98,selTransTbl[21]))(objcT98,selTransTbl[21]));
}

static id i_ClassDef_ivarnames(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->ivarnames;
}

static id i_ClassDef_cvarnames(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->cvarnames;
}

static id i_ClassDef_synth(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT99,objcT100,objcT101,objcT102,objcT103;

#line 438 "classdef.m"
char*s=(objcT99=(id)self,(*(char*(*)(id,SEL))_imp(objcT99,selTransTbl[5]))(objcT99,selTransTbl[5]));

(objcT100=(id)self,(*_imp(objcT100,selTransTbl[12]))(objcT100,selTransTbl[12]));
if(self->superc)self->
shartypename=(objcT101=self->superc,(*(char*(*)(id,SEL))_imp(objcT101,selTransTbl[27]))(objcT101,selTransTbl[27]));
if(self->cvars)self->
shartypename=(objcT102=(objcT103=String,(*(id(*)(id,SEL,STR,...))_imp(objcT103,selTransTbl[2]))(objcT103,selTransTbl[2],"%s_SHARED",s)),(*(STR(*)(id,SEL))_imp(objcT102,selTransTbl[8]))(objcT102,selTransTbl[8]));
curstruct=(id)self;
if(self->ivars){
id objcT104,objcT105;

#line 447 "classdef.m"
(objcT104=self->ivars,(*(id(*)(id,SEL,SEL))_imp(objcT104,selTransTbl[18]))(objcT104,selTransTbl[18],_cmd));
(objcT105=(id)self,(*_imp(objcT105,selTransTbl[28]))(objcT105,selTransTbl[28]));
}
if(self->cvars){
id objcT106,objcT107;

#line 451 "classdef.m"
(objcT106=self->cvars,(*(id(*)(id,SEL,SEL))_imp(objcT106,selTransTbl[18]))(objcT106,selTransTbl[18],_cmd));
(objcT107=(id)self,(*_imp(objcT107,selTransTbl[29]))(objcT107,selTransTbl[29]));
}
curstruct=(id)0;
return(id)self;
}

static id i_ClassDef_genlineno(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT108,objcT109,objcT110;

#line 460 "classdef.m"
gl((objcT108=self->classname,(*(int(*)(id,SEL))_imp(objcT108,selTransTbl[19]))(objcT108,selTransTbl[19])),(objcT109=(objcT110=self->classname,(*_imp(objcT110,selTransTbl[20]))(objcT110,selTransTbl[20])),(*(STR(*)(id,SEL))_imp(objcT109,selTransTbl[6]))(objcT109,selTransTbl[6])));
return(id)self;
}

static id i_ClassDef_genivars(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT111,objcT112;

#line 466 "classdef.m"
if(self->superc)
(objcT111=self->superc,(*_imp(objcT111,selTransTbl[30]))(objcT111,selTransTbl[30]));
if(self->ivars)
(objcT112=self->ivars,(*(id(*)(id,SEL,SEL))_imp(objcT112,selTransTbl[18]))(objcT112,selTransTbl[18],selTransTbl[31]));
return(id)self;
}

static id i_ClassDef_gencvars(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT113,objcT114;

#line 475 "classdef.m"
if(self->superc)
(objcT113=self->superc,(*_imp(objcT113,selTransTbl[32]))(objcT113,selTransTbl[32]));
if(self->cvars)
(objcT114=self->cvars,(*(id(*)(id,SEL,SEL))_imp(objcT114,selTransTbl[18]))(objcT114,selTransTbl[18],selTransTbl[31]));
return(id)self;
}

static id i_ClassDef_genprivtype(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT115,objcT116,objcT117,objcT118,objcT119;

#line 484 "classdef.m"
id s=(objcT115=String,(*(id(*)(id,SEL,STR))_imp(objcT115,selTransTbl[33]))(objcT115,selTransTbl[33],self->privtypename));

if((objcT116=trlunit,(*(BOOL(*)(id,SEL,id))_imp(objcT116,selTransTbl[34]))(objcT116,selTransTbl[34],s)))
return(id)self;
(objcT117=trlunit,(*_imp(objcT117,selTransTbl[35]))(objcT117,selTransTbl[35],s));

(objcT118=(id)self,(*_imp(objcT118,selTransTbl[36]))(objcT118,selTransTbl[36]));
gf("struct %s {\n",self->privtypename);
(objcT119=(id)self,(*_imp(objcT119,selTransTbl[30]))(objcT119,selTransTbl[30]));
gs("};\n");
if(o_otb){
gf("struct %s {\n",self->otbtypename);
gf("  struct %s *ptr;\n",self->privtypename);
g_otbvars();
gs("};\n");
}
return(id)self;
}

static id i_ClassDef_genshartype(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT120,objcT121,objcT122,objcT123;

#line 505 "classdef.m"
id s=(objcT120=String,(*(id(*)(id,SEL,STR))_imp(objcT120,selTransTbl[33]))(objcT120,selTransTbl[33],self->shartypename));

if((objcT121=trlunit,(*(BOOL(*)(id,SEL,id))_imp(objcT121,selTransTbl[34]))(objcT121,selTransTbl[34],s)))
return(id)self;
(objcT122=trlunit,(*_imp(objcT122,selTransTbl[35]))(objcT122,selTransTbl[35],s));


gf("struct %s {\n",self->shartypename);
gs("  id isa;\n");
if(o_refcnt){
gs("  unsigned int _refcnt;\n");
}
gs("  id clsSuper;\n");
gs("  char *clsName;\n");
gs("  char *clsTypes;\n");
gs("  short clsSizInstance;\n");
gs("  short clsSizDict;\n");
gs("  struct _SLT *clsDispTable;\n");
gs("  long clsStatus;\n");
gs("  struct modDescriptor *clsMod;\n");

gs("  unsigned clsVersion;\n");

gs("  id clsCats;\n");
gs("  id *clsGlbl;\n");
(objcT123=(id)self,(*_imp(objcT123,selTransTbl[32]))(objcT123,selTransTbl[32]));
gs("};\n");
return(id)self;
}

static id i_ClassDef_genslt_(struct ClassDef_PRIVATE *self,SEL _cmd,id methdef)
{
if(o_cplus){
id objcT124,objcT125;

#line 538 "classdef.m"
gf("\n{\"%s\",(id (*)(...))%s},",(objcT124=methdef,(*(char*(*)(id,SEL))_imp(objcT124,selTransTbl[37]))(objcT124,selTransTbl[37])),(objcT125=methdef,(*(char*(*)(id,SEL))_imp(objcT125,selTransTbl[38]))(objcT125,selTransTbl[38])));
}else{
id objcT126,objcT127;

#line 540 "classdef.m"
gf("\n{\"%s\",(id (*)())%s},",(objcT126=methdef,(*(char*(*)(id,SEL))_imp(objcT126,selTransTbl[37]))(objcT126,selTransTbl[37])),(objcT127=methdef,(*(char*(*)(id,SEL))_imp(objcT127,selTransTbl[38]))(objcT127,selTransTbl[38])));
}
return(id)self;
}

static id i_ClassDef_gennilslt(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if(o_cplus){
gs("\n{(char*)0,(id (*)(...))0}");
}else{
gs("\n{(char*)0,(id (*)())0}");
}
return(id)self;
}

static id i_ClassDef_genclsdisptbl(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT128,objcT131;

#line 557 "classdef.m"
int i,n;

n=(self->clsdisptbl)?(objcT128=self->clsdisptbl,(*(unsigned(*)(id,SEL))_imp(objcT128,selTransTbl[13]))(objcT128,selTransTbl[13])):0;
gf("static struct _SLT %s[] ={",self->clsdisptblname);
for(i=0;i<n;i++){
id objcT129,objcT130;

#line 562 "classdef.m"
(objcT129=(id)self,(*_imp(objcT129,selTransTbl[39]))(objcT129,selTransTbl[39],(objcT130=self->clsdisptbl,(*(id(*)(id,SEL,unsigned))_imp(objcT130,selTransTbl[14]))(objcT130,selTransTbl[14],i))));
}
(objcT131=(id)self,(*_imp(objcT131,selTransTbl[40]))(objcT131,selTransTbl[40]));
gs("\n};\n");
return(id)self;
}

static id i_ClassDef_gennstdisptbl(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT132,objcT135;

#line 571 "classdef.m"
int i,n;

n=(self->nstdisptbl)?(objcT132=self->nstdisptbl,(*(unsigned(*)(id,SEL))_imp(objcT132,selTransTbl[13]))(objcT132,selTransTbl[13])):0;
gf("static struct _SLT %s[] ={",self->nstdisptblname);
for(i=0;i<n;i++){
id objcT133,objcT134;

#line 576 "classdef.m"
(objcT133=(id)self,(*_imp(objcT133,selTransTbl[39]))(objcT133,selTransTbl[39],(objcT134=self->nstdisptbl,(*(id(*)(id,SEL,unsigned))_imp(objcT134,selTransTbl[14]))(objcT134,selTransTbl[14],i))));
}
(objcT135=(id)self,(*_imp(objcT135,selTransTbl[40]))(objcT135,selTransTbl[40]));
gs("\n};\n");
return(id)self;
}

#line 594 "classdef.m"
static id i_ClassDef_genclassimpl(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT137,objcT138,objcT139,objcT140;

#line 596 "classdef.m"
long st;

if( !self->iscategory){
st=0x1L|0x8L|0x20L;
}else{
st=0x1L|0x8L|0x20L|0x40L;
}
if(o_refcnt){
st|=0x80L;
}
gf("struct %s ",self->shartypename);

if( !o_otb){
gf(" %s = {\n",self->_classname);
}else{
gf(" %s_OTB = {\n",self->_classname);
}

gf("  (id)&%s,",self->_m_classname);
gcom("/* isa */");

if(o_refcnt){
gs("  1,");
gcom("/* _refcnt */");
}

if(self->superc!=(id)0&&o_shareddata){
id objcT136;

#line 623 "classdef.m"
gf("  (id)&%s,",(objcT136=self->superc,(*(char*(*)(id,SEL))_imp(objcT136,selTransTbl[41]))(objcT136,selTransTbl[41])));
gcom("/* clsSuper */");
}else{
gf("  0,");
gcom("/* clsSuper */");
}

gf("  \"%s\",",(objcT137=(id)self,(*(char*(*)(id,SEL))_imp(objcT137,selTransTbl[5]))(objcT137,selTransTbl[5])));
gcom("/* clsName */");
gs("  0,");
gcom("/* clsTypes */");
gf("  sizeof(struct %s),",self->privtypename);
gcom("/* clsSizInstance */");
gf("  %d,",(self->nstdisptbl)?(objcT138=self->nstdisptbl,(*(unsigned(*)(id,SEL))_imp(objcT138,selTransTbl[13]))(objcT138,selTransTbl[13])):0);
gcom("/* clsSizDict */");
gf("  %s,",self->nstdisptblname);
gcom("/* _nstDispatchTbl */");
gf("  %d,",st);
gcom("/* clsStatus */");
gf("  &%s,",(objcT139=trlunit,(*(char*(*)(id,SEL))_imp(objcT139,selTransTbl[42]))(objcT139,selTransTbl[42])));
gcom("/* clsMod */");
gs("  0,");
gcom("/* clsVersion */");
gs("  (id)0,");
gcom("/* OBSOLETE - clsCats */");
gf("  &%s,",(objcT140=(id)self,(*(char*(*)(id,SEL))_imp(objcT140,selTransTbl[5]))(objcT140,selTransTbl[5])));
gcom("/* clsGlbl */");
gs("};\n");

if(o_otb){
char*z=self->_classname;

gf("struct OTB %s={ (struct _PRIVATE*)&%s_OTB,0,0 };\n",z,z);
}
gf("id %s %s(void)",o_bind,self->_classfunname);
gf(" { return (id)&%s; }\n",self->_classname);

gf("id %s %s(void)",o_bind,self->_superfunname);
if( !o_otb){
gf(" { return %s.clsSuper; }\n",self->_classname);
}else{
gf(" { return %s_OTB.clsSuper; }\n",self->_classname);
}

return(id)self;
}

static id i_ClassDef_genmetaimpl(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT144,objcT145,objcT146;

#line 672 "classdef.m"
long st=0x2L|0x20L;

if(o_refcnt){
st|=0x80L;
}
if( !o_otb){
gf("struct _SHARED %s = {\n",self->_m_classname);
}else{
gf("struct _SHARED %s_OTB = {\n",self->_m_classname);
}

if(o_shareddata){
id objcT141;

#line 684 "classdef.m"
gf("  (id)&%s,",(objcT141=self->rootc,(*(char*(*)(id,SEL))_imp(objcT141,selTransTbl[43]))(objcT141,selTransTbl[43])));
gcom("/* isa */");
}else{
gs("  (id)0,");
gcom("/* isa */");
}

if(o_refcnt){
gs("  1,");
gcom("/* _refcnt */");
}
if(o_shareddata){
if(self->superc){
id objcT142;

#line 697 "classdef.m"
gf("  (id)&%s,",(objcT142=self->superc,(*(char*(*)(id,SEL))_imp(objcT142,selTransTbl[43]))(objcT142,selTransTbl[43])));
gcom("/* clsSuper */");
}else{
id objcT143;
gf("  (id)&%s,",(objcT143=self->rootc,(*(char*(*)(id,SEL))_imp(objcT143,selTransTbl[41]))(objcT143,selTransTbl[41])));
gcom("/* clsSuper */");
}
}else{
gs("  (id)0,");
gcom("/* clsSuper */");
}

gf("  \"%s\",",(objcT144=(id)self,(*(char*(*)(id,SEL))_imp(objcT144,selTransTbl[5]))(objcT144,selTransTbl[5])));
gcom("/* clsName */");
gs("  0,");
gcom("/* clsTypes */");
gf("  sizeof(struct %s),",self->shartypename);
gcom("/* clsSizInstance */");
gf("  %d,",(self->clsdisptbl)?(objcT145=self->clsdisptbl,(*(unsigned(*)(id,SEL))_imp(objcT145,selTransTbl[13]))(objcT145,selTransTbl[13])):0);
gcom("/* clsSizDict */");
gf("  %s,",self->clsdisptblname);
gcom("/* _clsDispatchTbl */");
gf("  %d,",st);
gcom("/* clsStatus */");
gf("  &%s,",(objcT146=trlunit,(*(char*(*)(id,SEL))_imp(objcT146,selTransTbl[42]))(objcT146,selTransTbl[42])));
gcom("/* clsMod */");
gs("  0,");
gcom("/* clsVersion */");
gs("  (id)0,");
gcom("/* OBSOLETE clsCats */");
gs("  0,");
gcom("/* clsGlbl */");
gs("};\n");

if(o_otb){
char*z=self->_m_classname;

gf("struct OTB %s={ (struct _PRIVATE*)&%s_OTB,0,0 };\n",z,z);
}
gf("id %s %s(void)",o_bind,self->_m_classfunname);
gf(" { return (id)&%s; }\n",self->_m_classname);

gf("id %s %s(void)",o_bind,self->_m_superfunname);
if( !o_otb){
gf(" { return %s.clsSuper; }\n",self->_m_classname);
}else{
gf(" { return %s_OTB.clsSuper; }\n",self->_m_classname);
}

return(id)self;
}

static id i_ClassDef_genclassglobal(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT147;

#line 751 "classdef.m"
char*s=(objcT147=(id)self,(*(char*(*)(id,SEL))_imp(objcT147,selTransTbl[5]))(objcT147,selTransTbl[5]));

if( !o_shareddata)
gs("static");
gf("id %s = (id)&%s;\n",s,self->_classname);
gf("id %s *%s(void) { return &%s; }\n",o_bind,self->globfunname,s);
return(id)self;
}

static id i_ClassDef_genclassref(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if( !o_shareddata){(
void)0;
gf("*%s()",self->globfunname);
}else{
id objcT148;

#line 766 "classdef.m"
gs((objcT148=(id)self,(*(char*(*)(id,SEL))_imp(objcT148,selTransTbl[5]))(objcT148,selTransTbl[5])));
}
return(id)self;
}


static id i_ClassDef_genglobfuncall(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT150,objcT151,objcT152;

#line 774 "classdef.m"
char*s;

if(self->superc){
id objcT149;

#line 777 "classdef.m"
s=(objcT149=self->superc,(*(char*(*)(id,SEL))_imp(objcT149,selTransTbl[44]))(objcT149,selTransTbl[44]));
if( !o_otb){
gf("  %s.clsSuper = %s();\n",self->_classname,s);
}else{
gf("  %s_OTB.clsSuper = %s();\n",self->_classname,s);
}
}
s=(objcT150=self->rootc,(*(char*(*)(id,SEL))_imp(objcT150,selTransTbl[45]))(objcT150,selTransTbl[45]));
if( !o_otb){
gf("  %s.isa = %s();\n",self->_m_classname,s);
}else{
gf("  %s_OTB.isa = %s();\n",self->_m_classname,s);
}

s=(self->superc)?(objcT151=self->superc,(*(char*(*)(id,SEL))_imp(objcT151,selTransTbl[45]))(objcT151,selTransTbl[45])):(objcT152=self->rootc,(*(char*(*)(id,SEL))_imp(objcT152,selTransTbl[44]))(objcT152,selTransTbl[44]));
if( !o_otb){
gf("  %s.clsSuper = %s();\n",self->_m_classname,s);
}else{
gf("  %s_OTB.clsSuper = %s();\n",self->_m_classname,s);
}

return(id)self;
}

static id i_ClassDef_gen(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if(self->isimpl){
id objcT153,objcT154,objcT155;

#line 804 "classdef.m"
(objcT153=(id)self,(*_imp(objcT153,selTransTbl[46]))(objcT153,selTransTbl[46]));
(objcT154=(id)self,(*_imp(objcT154,selTransTbl[47]))(objcT154,selTransTbl[47]));
(objcT155=(id)self,(*_imp(objcT155,selTransTbl[48]))(objcT155,selTransTbl[48]));
}
return(id)self;
}

static id i_ClassDef_gensuper(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if(o_otb|| !o_shareddata){
gf("%s()",self->_superfunname);
}else{
gf("%s.clsSuper",self->_classname);
}
return(id)self;
}

static id i_ClassDef_genmetasuper(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if(o_otb|| !o_shareddata){
gf("%s()",self->_m_superfunname);
}else{
gf("%s.clsSuper",self->_m_classname);
}
return(id)self;
}

static id i_ClassDef_use(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT156;

#line 833 "classdef.m"
if( !o_postlink)
(objcT156=trlunit,(*_imp(objcT156,selTransTbl[49]))(objcT156,selTransTbl[49],self->classname));
return(id)self;
}

static id i_ClassDef_define(struct ClassDef_PRIVATE *self,SEL _cmd)
{
id objcT157,objcT158;

#line 840 "classdef.m"
(objcT157=trlunit,(*_imp(objcT157,selTransTbl[50]))(objcT157,selTransTbl[50],(id)self));
if( !o_postlink)
(objcT158=trlunit,(*_imp(objcT158,selTransTbl[51]))(objcT158,selTransTbl[51],self->classname));
return(id)self;
}

static BOOL i_ClassDef_isimpl(struct ClassDef_PRIVATE *self,SEL _cmd)
{
return self->isimpl;
}

static id i_ClassDef_forceimpl(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if(self->isimpl){
return(id)self;
}else{
id objcT159,objcT160;
self->
#line 856 "classdef.m"
isimpl=(BOOL)1;
(objcT159=(id)self,(*_imp(objcT159,selTransTbl[52]))(objcT159,selTransTbl[52]));
(objcT160=self->superc,(*_imp(objcT160,selTransTbl[53]))(objcT160,selTransTbl[53]));
return(id)self;
}
}

static id i_ClassDef_genintf(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if(self->emitintf){
return(id)self;
}else{
id objcT161;
self->
#line 868 "classdef.m"
emitintf=(BOOL)1;
(objcT161=(id)self,(*_imp(objcT161,selTransTbl[36]))(objcT161,selTransTbl[36]));
if(o_shareddata){
id objcT162;

#line 871 "classdef.m"
gf("extern id %s %s;\n",o_bind,(objcT162=(id)self,(*(char*(*)(id,SEL))_imp(objcT162,selTransTbl[5]))(objcT162,selTransTbl[5])));
}else{

gf("extern id %s *%s(void);\n",o_bind,self->globfunname);
}
return(id)self;
}
}

static id i_ClassDef_genfwddecl(struct ClassDef_PRIVATE *self,SEL _cmd)
{

if(self->emitfwddecl){
return(id)self;
}else{
id objcT163,objcT164;
self->
#line 886 "classdef.m"
emitfwddecl=(BOOL)1;
(objcT163=(id)self,(*_imp(objcT163,selTransTbl[54]))(objcT163,selTransTbl[54]));
(objcT164=(id)self,(*_imp(objcT164,selTransTbl[36]))(objcT164,selTransTbl[36]));
if( !o_otb){
gf("extern struct %s %s;\n",self->shartypename,self->_classname);
gf("extern struct _SHARED %s;\n",self->_m_classname);
}else{(
void)0;
gf("extern struct OTB %s;\n",self->_classname);
gf("extern struct %s %s_OTB;\n",self->shartypename,self->_classname);
gf("extern struct OTB %s;\n",self->_m_classname);
gf("extern struct _SHARED %s_OTB;\n",self->_m_classname);
}
if( !o_shareddata){
gf("extern id %s %s(void);\n",o_bind,self->_classfunname);
gf("extern id %s %s(void);\n",o_bind,self->_superfunname);
gf("extern id %s %s(void);\n",o_bind,self->_m_classfunname);
gf("extern id %s %s(void);\n",o_bind,self->_m_superfunname);
}
return(id)self;
}
}

static id i_ClassDef_genimpl(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if(self->emitimpl){
return(id)self;
}else{
id objcT165,objcT166,objcT167,objcT168,objcT169;
id objcT174,objcT175,objcT176,objcT177,objcT178;
self->
#line 914 "classdef.m"
emitimpl=(BOOL)1;
(objcT165=self->rootc,(*_imp(objcT165,selTransTbl[48]))(objcT165,selTransTbl[48]));
if(self->superc)
(objcT166=self->superc,(*_imp(objcT166,selTransTbl[48]))(objcT166,selTransTbl[48]));
(objcT167=(id)self,(*_imp(objcT167,selTransTbl[48]))(objcT167,selTransTbl[48]));
(objcT168=(id)self,(*_imp(objcT168,selTransTbl[46]))(objcT168,selTransTbl[46]));
(objcT169=(id)self,(*_imp(objcT169,selTransTbl[47]))(objcT169,selTransTbl[47]));
o_nolinetags++;
if(self->fileinmethod){
id objcT170;

#line 923 "classdef.m"
(objcT170=self->fileinmethod,(*_imp(objcT170,selTransTbl[31]))(objcT170,selTransTbl[31]));
gc('\n');
}
if(self->fileoutmethod){
id objcT171;

#line 927 "classdef.m"
(objcT171=self->fileoutmethod,(*_imp(objcT171,selTransTbl[31]))(objcT171,selTransTbl[31]));
gc('\n');
}
if(self->decrefsmethod){
id objcT172;

#line 931 "classdef.m"
(objcT172=self->decrefsmethod,(*_imp(objcT172,selTransTbl[31]))(objcT172,selTransTbl[31]));
gc('\n');
}
if(self->increfsmethod){
id objcT173;

#line 935 "classdef.m"
(objcT173=self->increfsmethod,(*_imp(objcT173,selTransTbl[31]))(objcT173,selTransTbl[31]));
gc('\n');
}
(objcT174=(id)self,(*_imp(objcT174,selTransTbl[55]))(objcT174,selTransTbl[55]));
(objcT175=(id)self,(*_imp(objcT175,selTransTbl[56]))(objcT175,selTransTbl[56]));
(objcT176=(id)self,(*_imp(objcT176,selTransTbl[57]))(objcT176,selTransTbl[57]));
(objcT177=(id)self,(*_imp(objcT177,selTransTbl[58]))(objcT177,selTransTbl[58]));
(objcT178=(id)self,(*_imp(objcT178,selTransTbl[59]))(objcT178,selTransTbl[59]));
o_nolinetags--;
return(id)self;
}
}

#line 32 "../../include/objpak/dictnary.h"
extern id  Dictionary;

#line 948 "classdef.m"
static id i_ClassDef_defcomp_astype_(struct ClassDef_PRIVATE *self,SEL _cmd,id sym,id t)
{
id objcT182,objcT183;

#line 950 "classdef.m"
if( !self->compdic){
id objcT179,objcT180,objcT181;
self->
#line 951 "classdef.m"
compdic=(objcT179=Dictionary,(*_imp(objcT179,selTransTbl[0]))(objcT179,selTransTbl[0]));self->
compnames=(objcT180=OrdCltn,(*_imp(objcT180,selTransTbl[0]))(objcT180,selTransTbl[0]));self->
comptypes=(objcT181=OrdCltn,(*_imp(objcT181,selTransTbl[0]))(objcT181,selTransTbl[0]));
}
if(self->superc&&((objcT182=self->superc,(*(BOOL(*)(id,SEL,id))_imp(objcT182,selTransTbl[60]))(objcT182,selTransTbl[60],sym))||(objcT183=self->superc,(*(BOOL(*)(id,SEL,id))_imp(objcT183,selTransTbl[61]))(objcT183,selTransTbl[61],sym)))){
id objcT184,objcT187,objcT188;

#line 956 "classdef.m"
id which,next;

for(which=self->superc,next=(objcT184=which,(*_imp(objcT184,selTransTbl[11]))(objcT184,selTransTbl[11]));next;which=next){
id objcT185,objcT186;

#line 959 "classdef.m"
if( !((objcT185=next,(*(BOOL(*)(id,SEL,id))_imp(objcT185,selTransTbl[60]))(objcT185,selTransTbl[60],sym))||(objcT186=next,(*(BOOL(*)(id,SEL,id))_imp(objcT186,selTransTbl[61]))(objcT186,selTransTbl[61],sym))))
break;
}
fatalat(sym,"'%s' previously declared by '%s'",(objcT187=sym,(*(STR(*)(id,SEL))_imp(objcT187,selTransTbl[6]))(objcT187,selTransTbl[6])),(objcT188=which,(*(char*(*)(id,SEL))_imp(objcT188,selTransTbl[5]))(objcT188,selTransTbl[5])));
}else{
id objcT189,objcT190,objcT191;

#line 964 "classdef.m"
(objcT189=self->compdic,(*_imp(objcT189,selTransTbl[62]))(objcT189,selTransTbl[62],sym,t));
(objcT190=self->compnames,(*_imp(objcT190,selTransTbl[23]))(objcT190,selTransTbl[23],sym));
(objcT191=self->comptypes,(*_imp(objcT191,selTransTbl[23]))(objcT191,selTransTbl[23],t));
}
return(id)self;
}

static id i_ClassDef_lookupivar_(struct ClassDef_PRIVATE *self,SEL _cmd,id sym)
{
id objcT192,objcT193;

#line 973 "classdef.m"
id t;

if(self->ivardic&&(t=(objcT192=self->ivardic,(*_imp(objcT192,selTransTbl[63]))(objcT192,selTransTbl[63],sym))))
return t;
return(self->superc)?(objcT193=self->superc,(*_imp(objcT193,selTransTbl[64]))(objcT193,selTransTbl[64],sym)):(id)0;
}

static id i_ClassDef_lookupcvar_(struct ClassDef_PRIVATE *self,SEL _cmd,id sym)
{
id objcT194,objcT195;

#line 982 "classdef.m"
id t;

if(self->cvardic&&(t=(objcT194=self->cvardic,(*_imp(objcT194,selTransTbl[63]))(objcT194,selTransTbl[63],sym))))
return t;
return(self->superc)?(objcT195=self->superc,(*_imp(objcT195,selTransTbl[65]))(objcT195,selTransTbl[65],sym)):(id)0;
}

static BOOL i_ClassDef_isivar_(struct ClassDef_PRIVATE *self,SEL _cmd,id sym)
{
id objcT200;

#line 991 "classdef.m"
if( !self->allivarnames){
id objcT196,objcT197;

#line 992 "classdef.m"
id x,c;self->

allivarnames=(objcT196=Set,(*_imp(objcT196,selTransTbl[0]))(objcT196,selTransTbl[0]));
for(c=(id)self;c;c=(objcT197=c,(*_imp(objcT197,selTransTbl[11]))(objcT197,selTransTbl[11]))){
id objcT198,objcT199;

#line 996 "classdef.m"
if((x=(objcT198=c,(*_imp(objcT198,selTransTbl[66]))(objcT198,selTransTbl[66]))))
(objcT199=self->allivarnames,(*_imp(objcT199,selTransTbl[67]))(objcT199,selTransTbl[67],x));
}
}
return(objcT200=self->allivarnames,(*(BOOL(*)(id,SEL,id))_imp(objcT200,selTransTbl[68]))(objcT200,selTransTbl[68],sym));
}

static BOOL i_ClassDef_iscvar_(struct ClassDef_PRIVATE *self,SEL _cmd,id sym)
{
id objcT205,objcT206;

#line 1005 "classdef.m"
BOOL iscvar;

if( !self->allcvarnames){
id objcT201,objcT202;

#line 1008 "classdef.m"
id x,c;self->

allcvarnames=(objcT201=Set,(*_imp(objcT201,selTransTbl[0]))(objcT201,selTransTbl[0]));
for(c=(id)self;c;c=(objcT202=c,(*_imp(objcT202,selTransTbl[11]))(objcT202,selTransTbl[11]))){
id objcT203,objcT204;

#line 1012 "classdef.m"
if((x=(objcT203=c,(*_imp(objcT203,selTransTbl[69]))(objcT203,selTransTbl[69]))))
(objcT204=self->allcvarnames,(*_imp(objcT204,selTransTbl[67]))(objcT204,selTransTbl[67],x));
}
}
iscvar=(objcT205=self->allcvarnames,(*(BOOL(*)(id,SEL,id))_imp(objcT205,selTransTbl[68]))(objcT205,selTransTbl[68],sym));
if(iscvar&&(objcT206=trlunit,(*(BOOL(*)(id,SEL))_imp(objcT206,selTransTbl[70]))(objcT206,selTransTbl[70]))){
if(o_warnsuggest){
warnat(sym,"suggest using -noSelfAssign when using class variables");
}
}
return iscvar;
}

static id i_ClassDef_st80(struct ClassDef_PRIVATE *self,SEL _cmd)
{
if(self->isimpl&& !self->emitimpl){
id objcT207,objcT208,objcT209,objcT210;

#line 1028 "classdef.m"
char*sn;

gs("\f\n");self->
emitimpl++;
sn=(self->superc)?(objcT207=self->superc,(*(char*(*)(id,SEL))_imp(objcT207,selTransTbl[5]))(objcT207,selTransTbl[5])):"Meta";
gf("%s subclass: #%s\n",(objcT208=(id)self,(*(char*(*)(id,SEL))_imp(objcT208,selTransTbl[5]))(objcT208,selTransTbl[5])),sn);
gs("\tinstanceVariableNames: '");
(objcT209=self->ivarnames,(*(id(*)(id,SEL,SEL))_imp(objcT209,selTransTbl[18]))(objcT209,selTransTbl[18],_cmd));
gs("'\n");
gs("\tclassVariableNames: '");
(objcT210=self->cvarnames,(*(id(*)(id,SEL,SEL))_imp(objcT210,selTransTbl[18]))(objcT210,selTransTbl[18],_cmd));
gs("'\n");
gs("\tpoolDictionaries: ''\n");
gs("\tcategory: 'POC Generated'!\n");
gc('\n');
}
return(id)self;
}
extern id  Object;
extern struct _SHARED _Object;
extern struct _SHARED __Object;
extern id  Node;
extern struct _SHARED _Node;
extern struct _SHARED __Node;
static struct _SLT _ClassDef_clsDispatchTbl[] ={
{"new",(id (*)())c_ClassDef_new},
{(char*)0,(id (*)())0}
};
static struct _SLT _ClassDef_nstDispatchTbl[] ={
{"privtypename",(id (*)())i_ClassDef_privtypename},
{"selftype",(id (*)())i_ClassDef_selftype},
{"shartypename",(id (*)())i_ClassDef_shartypename},
{"otbtypename",(id (*)())i_ClassDef_otbtypename},
{"shartypename:",(id (*)())i_ClassDef_shartypename_},
{"warnpending",(id (*)())i_ClassDef_warnpending},
{"classname:",(id (*)())i_ClassDef_classname_},
{"checksupername:",(id (*)())i_ClassDef_checksupername_},
{"supername:",(id (*)())i_ClassDef_supername_},
{"classname",(id (*)())i_ClassDef_classname},
{"globfunname",(id (*)())i_ClassDef_globfunname},
{"_classname",(id (*)())i_ClassDef__classname},
{"_m_classname",(id (*)())i_ClassDef__m_classname},
{"_classfunname",(id (*)())i_ClassDef__classfunname},
{"_m_classfunname",(id (*)())i_ClassDef__m_classfunname},
{"_superfunname",(id (*)())i_ClassDef__superfunname},
{"_m_superfunname",(id (*)())i_ClassDef__m_superfunname},
{"supername",(id (*)())i_ClassDef_supername},
{"superclassdef",(id (*)())i_ClassDef_superclassdef},
{"rootclassdef",(id (*)())i_ClassDef_rootclassdef},
{"rootname",(id (*)())i_ClassDef_rootname},
{"numidivars",(id (*)())i_ClassDef_numidivars},
{"synthrefcntmethods",(id (*)())i_ClassDef_synthrefcntmethods},
{"synthfilermethods",(id (*)())i_ClassDef_synthfilermethods},
{"ivars",(id (*)())i_ClassDef_ivars},
{"ivars:",(id (*)())i_ClassDef_ivars_},
{"cvars",(id (*)())i_ClassDef_cvars},
{"cvars:",(id (*)())i_ClassDef_cvars_},
{"checkvars::::",(id (*)())i_ClassDef_checkvars____},
{"checkivars:",(id (*)())i_ClassDef_checkivars_},
{"checkcvars:",(id (*)())i_ClassDef_checkcvars_},
{"addclsdisp:",(id (*)())i_ClassDef_addclsdisp_},
{"addclssel:",(id (*)())i_ClassDef_addclssel_},
{"addnstdisp:",(id (*)())i_ClassDef_addnstdisp_},
{"addnstsel:",(id (*)())i_ClassDef_addnstsel_},
{"check:includedin:factory:",(id (*)())i_ClassDef_check_includedin_factory_},
{"warnimplnotfound",(id (*)())i_ClassDef_warnimplnotfound},
{"undefcomps",(id (*)())i_ClassDef_undefcomps},
{"defivars",(id (*)())i_ClassDef_defivars},
{"defcvars",(id (*)())i_ClassDef_defcvars},
{"ivarnames",(id (*)())i_ClassDef_ivarnames},
{"cvarnames",(id (*)())i_ClassDef_cvarnames},
{"synth",(id (*)())i_ClassDef_synth},
{"genlineno",(id (*)())i_ClassDef_genlineno},
{"genivars",(id (*)())i_ClassDef_genivars},
{"gencvars",(id (*)())i_ClassDef_gencvars},
{"genprivtype",(id (*)())i_ClassDef_genprivtype},
{"genshartype",(id (*)())i_ClassDef_genshartype},
{"genslt:",(id (*)())i_ClassDef_genslt_},
{"gennilslt",(id (*)())i_ClassDef_gennilslt},
{"genclsdisptbl",(id (*)())i_ClassDef_genclsdisptbl},
{"gennstdisptbl",(id (*)())i_ClassDef_gennstdisptbl},
{"genclassimpl",(id (*)())i_ClassDef_genclassimpl},
{"genmetaimpl",(id (*)())i_ClassDef_genmetaimpl},
{"genclassglobal",(id (*)())i_ClassDef_genclassglobal},
{"genclassref",(id (*)())i_ClassDef_genclassref},
{"genglobfuncall",(id (*)())i_ClassDef_genglobfuncall},
{"gen",(id (*)())i_ClassDef_gen},
{"gensuper",(id (*)())i_ClassDef_gensuper},
{"genmetasuper",(id (*)())i_ClassDef_genmetasuper},
{"use",(id (*)())i_ClassDef_use},
{"define",(id (*)())i_ClassDef_define},
{"isimpl",(id (*)())i_ClassDef_isimpl},
{"forceimpl",(id (*)())i_ClassDef_forceimpl},
{"genintf",(id (*)())i_ClassDef_genintf},
{"genfwddecl",(id (*)())i_ClassDef_genfwddecl},
{"genimpl",(id (*)())i_ClassDef_genimpl},
{"defcomp:astype:",(id (*)())i_ClassDef_defcomp_astype_},
{"lookupivar:",(id (*)())i_ClassDef_lookupivar_},
{"lookupcvar:",(id (*)())i_ClassDef_lookupcvar_},
{"isivar:",(id (*)())i_ClassDef_isivar_},
{"iscvar:",(id (*)())i_ClassDef_iscvar_},
{"st80",(id (*)())i_ClassDef_st80},
{(char*)0,(id (*)())0}
};
id ClassDef = (id)&_ClassDef;
id  *OBJCCLASS_ClassDef(void) { return &ClassDef; }
struct _SHARED  _ClassDef = {
  (id)&__ClassDef,
  (id)&_Node,
  "ClassDef",
  0,
  sizeof(struct ClassDef_PRIVATE),
  73,
  _ClassDef_nstDispatchTbl,
  41,
  &classdef_modDesc,
  0,
  (id)0,
  &ClassDef,
};
id  OBJCCFUNC_ClassDef(void) { return (id)&_ClassDef; }
id  OBJCCSUPER_ClassDef(void) { return _ClassDef.clsSuper; }
struct _SHARED __ClassDef = {
  (id)&__Object,
  (id)&__Node,
  "ClassDef",
  0,
  sizeof(struct _SHARED),
  1,
  _ClassDef_clsDispatchTbl,
  34,
  &classdef_modDesc,
  0,
  (id)0,
  0,
};
id  OBJCMFUNC_ClassDef(void) { return (id)&__ClassDef; }
id  OBJCMSUPER_ClassDef(void) { return __ClassDef.clsSuper; }
static char *_selTransTbl[] ={
"new",
"addspec:",
"sprintf:",
"decl:",
"shartypename:",
"classname",
"str",
"def:asclass:",
"strCopy",
"isEqual:",
"lookupclass:",
"superclassdef",
"rootclassdef",
"size",
"at:",
"isid",
"find:",
"synth",
"elementsPerform:",
"lineno",
"filename",
"undefcomps",
"checkvars::::",
"add:",
"selector",
"includes:",
"check:includedin:factory:",
"shartypename",
"defivars",
"defcvars",
"genivars",
"gen",
"gencvars",
"str:",
"isgentype:",
"addgentype:",
"genlineno",
"selname",
"impname",
"genslt:",
"gennilslt",
"_classname",
"moddescname",
"_m_classname",
"_classfunname",
"_m_classfunname",
"genprivtype",
"genshartype",
"genfwddecl",
"usesentry:",
"addclsimpl:",
"definesentry:",
"define",
"use",
"genintf",
"genclsdisptbl",
"gennstdisptbl",
"genclassglobal",
"genclassimpl",
"genmetaimpl",
"isivar:",
"iscvar:",
"atKey:put:",
"atKey:",
"lookupivar:",
"lookupcvar:",
"ivarnames",
"addAll:",
"contains:",
"cvarnames",
"usingselfassign",
0
};
struct modDescriptor classdef_modDesc = {
  "classdef",
  "objc2.3.8",
  0L,
  0,
  0,
  &ClassDef,
  71,
  _selTransTbl,
  0
};
struct modDescriptor *_OBJCBIND_classdef(void)
{
  selTransTbl = _selTransTbl;
  return &classdef_modDesc;
}
int _OBJCPOSTLINK_classdef = 1;


