#line 1 "rtrnstmt.m"
struct _PRIVATE { struct _PRIVATE *isa; };
typedef struct _PRIVATE *id;
struct _SHARED {
  id isa;
  id clsSuper;
  char *clsName;
  char *clsTypes;
  short clsSizInstance;
  short clsSizDict;
  struct _SLT *clsDispTable;
  long clsStatus;
  struct modDescriptor *clsMod;
  unsigned clsVersion;
  id clsCats;
  id *clsGlbl;
};
extern id  (* _imp(id,char*))();
extern id  (* _impSuper(id,char*))();
extern struct modDescriptor  *_OBJCBIND_rtrnstmt(void);
static char **selTransTbl;
struct _SLT {char *_cmd;id (*_imp)();};
struct modDescriptor {
  char *modName;
  char *modVersion;
  long modStatus;
  char *modMinSel;
  char *modMaxSel;
  id *modClsLst;
  short modSelRef;
  char **modSelTbl;
  struct methodDescriptor *modMapTbl;
};
extern struct modDescriptor rtrnstmt_modDesc;

#line 1 "../../util/stdarg.h"
#include <stdarg.h>

#line 1 "../../util/stdlib.h"
#include <stdlib.h>

#line 1 "../../util/assert.h"
#include <assert.h>

#line 1 "../../util/stdio.h"
#include <stdio.h>

#line 1 "../../util/stddef.h"
#include <stddef.h>

#line 70 "../../include/objcrt/objcrt.h"
typedef char*SEL;
typedef char*STR;
typedef char BOOL;
typedef FILE*IOD;
typedef id SHR;
#line 79 "../../include/objcrt/objcrt.h"
typedef id(*IMP)();


typedef void(*ARGIMP)(id,SEL,void*);
#line 102 "../../include/objcrt/objcrt.h"
extern BOOL msgFlag;
extern FILE*msgIOD;
extern FILE*dbgIOD;
extern BOOL allocFlag;
extern BOOL dbgFlag;
extern BOOL noCacheFlag;
extern BOOL noNilRcvr;
#line 115 "../../include/objcrt/objcrt.h"
SEL selUid(STR);
STR selName(SEL);
void dbg(char*fmt,...);
void prnstack(FILE*file);
void loadobjc(void*modPtr);
void unloadobjc(void*modPtr);
#line 124 "../../include/objcrt/objcrt.h"
IMP fwdimp(id,SEL,IMP);
IMP fwdimpSuper(id,SEL,IMP);
void fwdmsg(id,SEL,void*,ARGIMP);
id selptrfwd(id,SEL,id,id,id,id);


id idincref(id obj);
id idassign(id*lhs,id rhs);
id iddecref(id obj);

extern id(*_fileIn)(FILE*);
extern BOOL(*_fileOut)(FILE*,id);
extern BOOL(*_storeOn)(STR,id);
extern id(*_readFrom)(STR);
void setfilein(id(*f)(FILE*));
void setfileout(BOOL(*f)(FILE*,id));

extern id(*_showOn)(id,unsigned);

void*OC_Malloc(size_t);
void*OC_MallocAtomic(size_t);
void*OC_Calloc(size_t);
void*OC_Realloc(void*,size_t);
void*OC_Free(void*data);
#line 1 "../../util/string.h"
#include <string.h>

#line 22 "node.h"
extern FILE*gfile;
extern int inlineno;
extern id infilename;
extern int outlineno;
extern char*outfilename;
extern int exitstatus;

void gc(char c);
void gextc(void);
void gcom(char*cm);
void gvarlist(id c,char*sp,char*iz);
void gcommalist(id c);
void gs(char*str);
void gf(char*fmt,...);
void gl(int no,char*fn);
void g_otbvars(void);
void gstderr(void);
void gnormal(void);

void warn(char*fmt,...);
void warnat(id sym,char*fmt,...);
void fatal(char*fmt,...);
void fatalat(id sym,char*fmt,...);
#line 22 "expr.h"
extern id e_nil;
extern id e_self;
extern id e_cmd;
extern id e_super;
extern id e_aFiler;
extern id e_ft_id;
#line 22 "type.h"
extern id t_unknown;
extern id t_void;
extern id t_char;
extern id t_bool;
extern id t_int;
extern id t_long;
extern id t_double;
extern id t_str;
extern id t_sel;
extern id t_id;
#line 22 "compstmt.h"
extern id curcompound;
extern id curloopcompound;
#line 22 "classdef.h"
extern id curclassdef;
extern id curstruct;
#line 22 "options.h"
void defoptions(void);

extern int o_gnu;
extern int o_refcnt;
extern int o_ppi;
extern int o_watcom;
extern int o_ibmvac;
extern int o_msdos;
extern int o_enableasm;
extern int o_nolinetags;
extern int o_buffered;
extern int o_quiet;
extern int o_outputcode;
extern int o_version;
extern int o_otb;
extern int o_llkeyw;
extern int o_comments;
extern int o_seltranslation;
extern int o_categories;
extern int o_blocks;
extern int o_fwd;
extern int o_selptr;
extern int o_cache;
extern int o_filer;
extern int o_selfassign;
extern char*o_bind;
extern int o_refbind;
extern int o_inlinecache;
extern int o_cplus;
extern int o_gencode;
extern int o_st80;
extern int o_selfassign;
extern int o_nilrcvr;
extern int o_shareddata;
extern int o_oneperfile;
extern int o_cvars;
extern int o_warnlex;
extern int o_warnfwd;
extern int o_warnsuggest;
extern int o_warnintvar;
extern int o_warnclasstype;
extern int o_warntypeconflict;
extern int o_warnundefined;
extern int o_warnlocalnst;
extern int o_warnnotfound;
extern int o_warnmissingmethods;
extern int o_postlink;
extern char*o_infile;
extern char*o_outfile;
extern char*o_srcfilename;
extern char*o_initcall;
extern char*o_tagformat;
extern char*o_mainfun;
extern char*o_pathsep;
extern int o_debuginfo;
extern int o_checkbind;
extern int o_linemax;
extern int o_structassign;
#line 22 "def.h"
extern id curdef;
#line 22 "rtrnstmt.h"
struct ReturnStmt_PRIVATE {

#line 42 "../../include/objcrt/Object.h"
id isa;
#line 46 "../../include/objcrt/Object.h"
unsigned short attr;
unsigned short objID;
#line 24 "rtrnstmt.h"
id keyw;
id expr;
id label;
BOOL incretval;};

#line 22 "rtrnstmt.h"
extern id  ReturnStmt;

#line 22 "rtrnstmt.h"
extern struct _SHARED _ReturnStmt;
extern struct _SHARED __ReturnStmt;


#line 39 "rtrnstmt.m"
static id i_ReturnStmt_keyw_(struct ReturnStmt_PRIVATE *self,SEL _cmd,id aKeyw)
{self->
keyw=aKeyw;
return(id)self;
}

static id i_ReturnStmt_expr_(struct ReturnStmt_PRIVATE *self,SEL _cmd,id anExpr)
{self->
expr=anExpr;
return(id)self;
}

static id i_ReturnStmt_synth(struct ReturnStmt_PRIVATE *self,SEL _cmd)
{
id objcT0,objcT2;

#line 53 "rtrnstmt.m"
id c;

for(c=curcompound;c;c=(objcT0=c,(*_imp(objcT0,selTransTbl[0]))(objcT0,selTransTbl[0]))){
id objcT1;

#line 56 "rtrnstmt.m"
if((objcT1=c,(*(BOOL(*)(id,SEL))_imp(objcT1,selTransTbl[1]))(objcT1,selTransTbl[1]))){
fatalat(self->keyw,"non-local return from within block not yet supported");
}
}
(objcT2=self->expr,(*_imp(objcT2,selTransTbl[2]))(objcT2,selTransTbl[2]));
if(o_refcnt){
id objcT3;
self->
#line 62 "rtrnstmt.m"
label=(objcT3=curcompound,(*_imp(objcT3,selTransTbl[3]))(objcT3,selTransTbl[3]));
if(self->expr){
id objcT4,objcT5,objcT6;

#line 64 "rtrnstmt.m"
id t=(objcT4=self->expr,(*_imp(objcT4,selTransTbl[4]))(objcT4,selTransTbl[4]));

if( !(objcT5=self->expr,(*(BOOL(*)(id,SEL))_imp(objcT5,selTransTbl[5]))(objcT5,selTransTbl[5]))&&(objcT6=t,(*(BOOL(*)(id,SEL))_imp(objcT6,selTransTbl[6]))(objcT6,selTransTbl[6])))self->
incretval++;

else if(curclassdef){
id objcT7;
if(curdef&&(objcT7=curdef,(*(BOOL(*)(id,SEL))_imp(objcT7,selTransTbl[7]))(objcT7,selTransTbl[7]))){
id objcT8,objcT9;

#line 72 "rtrnstmt.m"
if((objcT8=t,(*(BOOL(*)(id,SEL,id))_imp(objcT8,selTransTbl[8]))(objcT8,selTransTbl[8],(objcT9=curclassdef,(*_imp(objcT9,selTransTbl[9]))(objcT9,selTransTbl[9])))))self->
incretval++;
}
}
}
}
return(id)self;
}

static id i_ReturnStmt_gen(struct ReturnStmt_PRIVATE *self,SEL _cmd)
{
if(self->label){
id objcT11;

#line 84 "rtrnstmt.m"
gs("if (1) { _returnflag++;");
if(self->expr){
id objcT10;

#line 86 "rtrnstmt.m"
gs("_returnval =");
(objcT10=self->expr,(*_imp(objcT10,selTransTbl[10]))(objcT10,selTransTbl[10]));
gc(';');
}
if(self->incretval)
gs("idincref(_returnval);");
gf("goto %s;}",(objcT11=self->label,(*(STR(*)(id,SEL))_imp(objcT11,selTransTbl[11]))(objcT11,selTransTbl[11])));
}else{
id objcT12,objcT13;

#line 94 "rtrnstmt.m"
if(self->keyw)
(objcT12=self->keyw,(*_imp(objcT12,selTransTbl[10]))(objcT12,selTransTbl[10]));
else
gs("return");
if(self->expr)
(objcT13=self->expr,(*_imp(objcT13,selTransTbl[10]))(objcT13,selTransTbl[10]));
gc(';');
}
return(id)self;
}

static id i_ReturnStmt_st80(struct ReturnStmt_PRIVATE *self,SEL _cmd)
{
id objcT14,objcT15;

#line 107 "rtrnstmt.m"
gc('^');
if(self->expr)
(objcT14=self->expr,(*_imp(objcT14,selTransTbl[12]))(objcT14,selTransTbl[12]));
else
(objcT15=e_self,(*_imp(objcT15,selTransTbl[12]))(objcT15,selTransTbl[12]));
gs(".\n");
return(id)self;
}
extern id  Object;
extern struct _SHARED _Object;
extern struct _SHARED __Object;
extern id  Stmt;
extern struct _SHARED _Stmt;
extern struct _SHARED __Stmt;
static struct _SLT _ReturnStmt_clsDispatchTbl[] ={
{(char*)0,(id (*)())0}
};
static struct _SLT _ReturnStmt_nstDispatchTbl[] ={
{"keyw:",(id (*)())i_ReturnStmt_keyw_},
{"expr:",(id (*)())i_ReturnStmt_expr_},
{"synth",(id (*)())i_ReturnStmt_synth},
{"gen",(id (*)())i_ReturnStmt_gen},
{"st80",(id (*)())i_ReturnStmt_st80},
{(char*)0,(id (*)())0}
};
id ReturnStmt = (id)&_ReturnStmt;
id  *OBJCCLASS_ReturnStmt(void) { return &ReturnStmt; }
struct _SHARED  _ReturnStmt = {
  (id)&__ReturnStmt,
  (id)&_Stmt,
  "ReturnStmt",
  0,
  sizeof(struct ReturnStmt_PRIVATE),
  5,
  _ReturnStmt_nstDispatchTbl,
  41,
  &rtrnstmt_modDesc,
  0,
  (id)0,
  &ReturnStmt,
};
id  OBJCCFUNC_ReturnStmt(void) { return (id)&_ReturnStmt; }
id  OBJCCSUPER_ReturnStmt(void) { return _ReturnStmt.clsSuper; }
struct _SHARED __ReturnStmt = {
  (id)&__Object,
  (id)&__Stmt,
  "ReturnStmt",
  0,
  sizeof(struct _SHARED),
  0,
  _ReturnStmt_clsDispatchTbl,
  34,
  &rtrnstmt_modDesc,
  0,
  (id)0,
  0,
};
id  OBJCMFUNC_ReturnStmt(void) { return (id)&__ReturnStmt; }
id  OBJCMSUPER_ReturnStmt(void) { return __ReturnStmt.clsSuper; }
static char *_selTransTbl[] ={
"enclosing",
"isblockexpr",
"synth",
"returnlabel",
"type",
"isconstexpr",
"isid",
"ismethdef",
"isEqual:",
"selftype",
"gen",
"str",
"st80",
0
};
struct modDescriptor rtrnstmt_modDesc = {
  "rtrnstmt",
  "objc2.3.8",
  0L,
  0,
  0,
  &ReturnStmt,
  13,
  _selTransTbl,
  0
};
struct modDescriptor *_OBJCBIND_rtrnstmt(void)
{
  selTransTbl = _selTransTbl;
  return &rtrnstmt_modDesc;
}
int _OBJCPOSTLINK_rtrnstmt = 1;


