#line 1 "enumsp.m"
struct _PRIVATE { struct _PRIVATE *isa; };
typedef struct _PRIVATE *id;
struct _SHARED {
  id isa;
  id clsSuper;
  char *clsName;
  char *clsTypes;
  short clsSizInstance;
  short clsSizDict;
  struct _SLT *clsDispTable;
  long clsStatus;
  struct modDescriptor *clsMod;
  unsigned clsVersion;
  id clsCats;
  id *clsGlbl;
};
extern id  (* _imp(id,char*))();
extern id  (* _impSuper(id,char*))();
extern struct modDescriptor  *_OBJCBIND_enumsp(void);
static char **selTransTbl;
struct _SLT {char *_cmd;id (*_imp)();};
struct modDescriptor {
  char *modName;
  char *modVersion;
  long modStatus;
  char *modMinSel;
  char *modMaxSel;
  id *modClsLst;
  short modSelRef;
  char **modSelTbl;
  struct methodDescriptor *modMapTbl;
};
extern struct modDescriptor enumsp_modDesc;

#line 1 "../../util/stdarg.h"
#include <stdarg.h>

#line 1 "../../util/stdlib.h"
#include <stdlib.h>

#line 1 "../../util/assert.h"
#include <assert.h>

#line 1 "../../util/stdio.h"
#include <stdio.h>

#line 1 "../../util/stddef.h"
#include <stddef.h>

#line 70 "../../include/objcrt/objcrt.h"
typedef char*SEL;
typedef char*STR;
typedef char BOOL;
typedef FILE*IOD;
typedef id SHR;
#line 79 "../../include/objcrt/objcrt.h"
typedef id(*IMP)();


typedef void(*ARGIMP)(id,SEL,void*);
#line 102 "../../include/objcrt/objcrt.h"
extern BOOL msgFlag;
extern FILE*msgIOD;
extern FILE*dbgIOD;
extern BOOL allocFlag;
extern BOOL dbgFlag;
extern BOOL noCacheFlag;
extern BOOL noNilRcvr;
#line 115 "../../include/objcrt/objcrt.h"
SEL selUid(STR);
STR selName(SEL);
void dbg(char*fmt,...);
void prnstack(FILE*file);
void loadobjc(void*modPtr);
void unloadobjc(void*modPtr);
#line 124 "../../include/objcrt/objcrt.h"
IMP fwdimp(id,SEL,IMP);
IMP fwdimpSuper(id,SEL,IMP);
void fwdmsg(id,SEL,void*,ARGIMP);
id selptrfwd(id,SEL,id,id,id,id);


id idincref(id obj);
id idassign(id*lhs,id rhs);
id iddecref(id obj);

extern id(*_fileIn)(FILE*);
extern BOOL(*_fileOut)(FILE*,id);
extern BOOL(*_storeOn)(STR,id);
extern id(*_readFrom)(STR);
void setfilein(id(*f)(FILE*));
void setfileout(BOOL(*f)(FILE*,id));

extern id(*_showOn)(id,unsigned);

void*OC_Malloc(size_t);
void*OC_MallocAtomic(size_t);
void*OC_Calloc(size_t);
void*OC_Realloc(void*,size_t);
void*OC_Free(void*data);
#line 1 "../../util/string.h"
#include <string.h>

#line 1 "../../util/stdio.h"
#include <stdio.h>

#line 31 "../../include/objpak/ordcltn.h"
typedef struct objcol{
int count;
int capacity;
id*ptr;
}*objcol_t;
#line 22 "node.h"
extern FILE*gfile;
extern int inlineno;
extern id infilename;
extern int outlineno;
extern char*outfilename;
extern int exitstatus;

void gc(char c);
void gextc(void);
void gcom(char*cm);
void gvarlist(id c,char*sp,char*iz);
void gcommalist(id c);
void gs(char*str);
void gf(char*fmt,...);
void gl(int no,char*fn);
void g_otbvars(void);
void gstderr(void);
void gnormal(void);

void warn(char*fmt,...);
void warnat(id sym,char*fmt,...);
void fatal(char*fmt,...);
void fatalat(id sym,char*fmt,...);
#line 22 "enumsp.h"
struct EnumSpec_PRIVATE {

#line 42 "../../include/objcrt/Object.h"
id isa;
#line 46 "../../include/objcrt/Object.h"
unsigned short attr;
unsigned short objID;
#line 24 "enumsp.h"
id keyw,name;
id lbrace;
id enumtors;
id rbrace;};

#line 22 "enumsp.h"
extern id  EnumSpec;

#line 22 "enumsp.h"
extern struct _SHARED _EnumSpec;
extern struct _SHARED __EnumSpec;


#line 33 "enumsp.m"
static id i_EnumSpec_keyw_(struct EnumSpec_PRIVATE *self,SEL _cmd,id akeyw)
{self->
keyw=akeyw;
return(id)self;
}

static id i_EnumSpec_name_(struct EnumSpec_PRIVATE *self,SEL _cmd,id akeyw)
{self->
name=akeyw;
return(id)self;
}

static id i_EnumSpec_lbrace_(struct EnumSpec_PRIVATE *self,SEL _cmd,id lb)
{self->
lbrace=lb;
return(id)self;
}

static id i_EnumSpec_rbrace_(struct EnumSpec_PRIVATE *self,SEL _cmd,id rb)
{self->
rbrace=rb;
return(id)self;
}

static id i_EnumSpec_enumtors_(struct EnumSpec_PRIVATE *self,SEL _cmd,id aList)
{(

void)0;self->
enumtors=aList;
return(id)self;
}

static id i_EnumSpec_synth(struct EnumSpec_PRIVATE *self,SEL _cmd)
{
id objcT0;

#line 67 "enumsp.m"
if(self->enumtors)
(objcT0=self->enumtors,(*(id(*)(id,SEL,SEL))_imp(objcT0,selTransTbl[0]))(objcT0,selTransTbl[0],_cmd));
return(id)self;
}

static id i_EnumSpec_gen(struct EnumSpec_PRIVATE *self,SEL _cmd)
{
id objcT1,objcT2;

#line 74 "enumsp.m"
(objcT1=self->keyw,(*_imp(objcT1,selTransTbl[1]))(objcT1,selTransTbl[1]));
(objcT2=self->name,(*_imp(objcT2,selTransTbl[1]))(objcT2,selTransTbl[1]));
if(self->enumtors){
id objcT3,objcT4,objcT11;

#line 77 "enumsp.m"
int comma=0;
int i,n=(objcT3=self->enumtors,(*(unsigned(*)(id,SEL))_imp(objcT3,selTransTbl[2]))(objcT3,selTransTbl[2]));

if(self->lbrace)
(objcT4=self->lbrace,(*_imp(objcT4,selTransTbl[1]))(objcT4,selTransTbl[1]));
else
gc('{');
if(n){
id objcT5,objcT6,objcT7;

#line 85 "enumsp.m"
id e=(objcT5=self->enumtors,(*(id(*)(id,SEL,unsigned))_imp(objcT5,selTransTbl[3]))(objcT5,selTransTbl[3],0));
(objcT6=e,(*_imp(objcT6,selTransTbl[1]))(objcT6,selTransTbl[1]));
comma=(objcT7=e,(*(BOOL(*)(id,SEL))_imp(objcT7,selTransTbl[4]))(objcT7,selTransTbl[4]));
}
for(i=1;i<n;i++){
id objcT8,objcT9,objcT10;

#line 90 "enumsp.m"
id e=(objcT8=self->enumtors,(*(id(*)(id,SEL,unsigned))_imp(objcT8,selTransTbl[3]))(objcT8,selTransTbl[3],i));
if(comma)gc(',');
(objcT9=e,(*_imp(objcT9,selTransTbl[1]))(objcT9,selTransTbl[1]));
comma=(objcT10=e,(*(BOOL(*)(id,SEL))_imp(objcT10,selTransTbl[4]))(objcT10,selTransTbl[4]));
}
if(self->rbrace)
(objcT11=self->rbrace,(*_imp(objcT11,selTransTbl[1]))(objcT11,selTransTbl[1]));
else
gc('}');
}
return(id)self;
}

static BOOL i_EnumSpec_canforward(struct EnumSpec_PRIVATE *self,SEL _cmd)
{
return(BOOL)1;
}

static BOOL i_EnumSpec_isselptr(struct EnumSpec_PRIVATE *self,SEL _cmd)
{
return(BOOL)0;
}
extern id  Object;
extern struct _SHARED _Object;
extern struct _SHARED __Object;
extern id  Node;
extern struct _SHARED _Node;
extern struct _SHARED __Node;
static struct _SLT _EnumSpec_clsDispatchTbl[] ={
{(char*)0,(id (*)())0}
};
static struct _SLT _EnumSpec_nstDispatchTbl[] ={
{"keyw:",(id (*)())i_EnumSpec_keyw_},
{"name:",(id (*)())i_EnumSpec_name_},
{"lbrace:",(id (*)())i_EnumSpec_lbrace_},
{"rbrace:",(id (*)())i_EnumSpec_rbrace_},
{"enumtors:",(id (*)())i_EnumSpec_enumtors_},
{"synth",(id (*)())i_EnumSpec_synth},
{"gen",(id (*)())i_EnumSpec_gen},
{"canforward",(id (*)())i_EnumSpec_canforward},
{"isselptr",(id (*)())i_EnumSpec_isselptr},
{(char*)0,(id (*)())0}
};
id EnumSpec = (id)&_EnumSpec;
id  *OBJCCLASS_EnumSpec(void) { return &EnumSpec; }
struct _SHARED  _EnumSpec = {
  (id)&__EnumSpec,
  (id)&_Node,
  "EnumSpec",
  0,
  sizeof(struct EnumSpec_PRIVATE),
  9,
  _EnumSpec_nstDispatchTbl,
  41,
  &enumsp_modDesc,
  0,
  (id)0,
  &EnumSpec,
};
id  OBJCCFUNC_EnumSpec(void) { return (id)&_EnumSpec; }
id  OBJCCSUPER_EnumSpec(void) { return _EnumSpec.clsSuper; }
struct _SHARED __EnumSpec = {
  (id)&__Object,
  (id)&__Node,
  "EnumSpec",
  0,
  sizeof(struct _SHARED),
  0,
  _EnumSpec_clsDispatchTbl,
  34,
  &enumsp_modDesc,
  0,
  (id)0,
  0,
};
id  OBJCMFUNC_EnumSpec(void) { return (id)&__EnumSpec; }
id  OBJCMSUPER_EnumSpec(void) { return __EnumSpec.clsSuper; }
static char *_selTransTbl[] ={
"elementsPerform:",
"gen",
"size",
"at:",
"isenumtor",
0
};
struct modDescriptor enumsp_modDesc = {
  "enumsp",
  "objc2.3.8",
  0L,
  0,
  0,
  &EnumSpec,
  5,
  _selTransTbl,
  0
};
struct modDescriptor *_OBJCBIND_enumsp(void)
{
  selTransTbl = _selTransTbl;
  return &enumsp_modDesc;
}
int _OBJCPOSTLINK_enumsp = 1;


