#line 1 "funbody.m"
struct _PRIVATE { struct _PRIVATE *isa; };
typedef struct _PRIVATE *id;
struct _SHARED {
  id isa;
  id clsSuper;
  char *clsName;
  char *clsTypes;
  short clsSizInstance;
  short clsSizDict;
  struct _SLT *clsDispTable;
  long clsStatus;
  struct modDescriptor *clsMod;
  unsigned clsVersion;
  id clsCats;
  id *clsGlbl;
};
extern id  (* _imp(id,char*))();
extern id  (* _impSuper(id,char*))();
extern struct modDescriptor  *_OBJCBIND_funbody(void);
static char **selTransTbl;
struct _SLT {char *_cmd;id (*_imp)();};
struct modDescriptor {
  char *modName;
  char *modVersion;
  long modStatus;
  char *modMinSel;
  char *modMaxSel;
  id *modClsLst;
  short modSelRef;
  char **modSelTbl;
  struct methodDescriptor *modMapTbl;
};
extern struct modDescriptor funbody_modDesc;

#line 1 "../../util/stdarg.h"
#include <stdarg.h>

#line 1 "../../util/stdlib.h"
#include <stdlib.h>

#line 1 "../../util/assert.h"
#include <assert.h>

#line 1 "../../util/stdio.h"
#include <stdio.h>

#line 1 "../../util/stddef.h"
#include <stddef.h>

#line 70 "../../include/objcrt/objcrt.h"
typedef char*SEL;
typedef char*STR;
typedef char BOOL;
typedef FILE*IOD;
typedef id SHR;
#line 79 "../../include/objcrt/objcrt.h"
typedef id(*IMP)();


typedef void(*ARGIMP)(id,SEL,void*);
#line 102 "../../include/objcrt/objcrt.h"
extern BOOL msgFlag;
extern FILE*msgIOD;
extern FILE*dbgIOD;
extern BOOL allocFlag;
extern BOOL dbgFlag;
extern BOOL noCacheFlag;
extern BOOL noNilRcvr;
#line 115 "../../include/objcrt/objcrt.h"
SEL selUid(STR);
STR selName(SEL);
void dbg(char*fmt,...);
void prnstack(FILE*file);
void loadobjc(void*modPtr);
void unloadobjc(void*modPtr);
#line 124 "../../include/objcrt/objcrt.h"
IMP fwdimp(id,SEL,IMP);
IMP fwdimpSuper(id,SEL,IMP);
void fwdmsg(id,SEL,void*,ARGIMP);
id selptrfwd(id,SEL,id,id,id,id);


id idincref(id obj);
id idassign(id*lhs,id rhs);
id iddecref(id obj);

extern id(*_fileIn)(FILE*);
extern BOOL(*_fileOut)(FILE*,id);
extern BOOL(*_storeOn)(STR,id);
extern id(*_readFrom)(STR);
void setfilein(id(*f)(FILE*));
void setfileout(BOOL(*f)(FILE*,id));

extern id(*_showOn)(id,unsigned);

void*OC_Malloc(size_t);
void*OC_MallocAtomic(size_t);
void*OC_Calloc(size_t);
void*OC_Realloc(void*,size_t);
void*OC_Free(void*data);
#line 1 "../../util/string.h"
#include <string.h>

#line 1 "../../util/stdio.h"
#include <stdio.h>

#line 31 "../../include/objpak/ordcltn.h"
typedef struct objcol{
int count;
int capacity;
id*ptr;
}*objcol_t;
#line 22 "node.h"
extern FILE*gfile;
extern int inlineno;
extern id infilename;
extern int outlineno;
extern char*outfilename;
extern int exitstatus;

void gc(char c);
void gextc(void);
void gcom(char*cm);
void gvarlist(id c,char*sp,char*iz);
void gcommalist(id c);
void gs(char*str);
void gf(char*fmt,...);
void gl(int no,char*fn);
void g_otbvars(void);
void gstderr(void);
void gnormal(void);

void warn(char*fmt,...);
void warnat(id sym,char*fmt,...);
void fatal(char*fmt,...);
void fatalat(id sym,char*fmt,...);
#line 22 "funbody.h"
struct FunctionBody_PRIVATE {

#line 42 "../../include/objcrt/Object.h"
id isa;
#line 46 "../../include/objcrt/Object.h"
unsigned short attr;
unsigned short objID;
#line 24 "funbody.h"
id datadefs,compound;};

#line 22 "funbody.h"
extern id  FunctionBody;

#line 22 "funbody.h"
extern struct _SHARED _FunctionBody;
extern struct _SHARED __FunctionBody;


#line 32 "funbody.m"
static id i_FunctionBody_compound(struct FunctionBody_PRIVATE *self,SEL _cmd){
return self->compound;
}
static id i_FunctionBody_datadefs_(struct FunctionBody_PRIVATE *self,SEL _cmd,id defs){self->
datadefs=defs;
return(id)self;
}
static id i_FunctionBody_compound_(struct FunctionBody_PRIVATE *self,SEL _cmd,id aCompound){self->
compound=aCompound;
return(id)self;
}

static id i_FunctionBody_gen(struct FunctionBody_PRIVATE *self,SEL _cmd)
{
id objcT0,objcT1;
(
#line 46 "funbody.m"
void)0;
if(self->datadefs)
(objcT0=self->datadefs,(*(id(*)(id,SEL,SEL))_imp(objcT0,selTransTbl[0]))(objcT0,selTransTbl[0],selTransTbl[1]));
(objcT1=self->compound,(*_imp(objcT1,selTransTbl[1]))(objcT1,selTransTbl[1]));
return(id)self;
}

static id i_FunctionBody_synth(struct FunctionBody_PRIVATE *self,SEL _cmd)
{
id objcT2,objcT3;
if(self->datadefs)
(objcT2=self->datadefs,(*(id(*)(id,SEL,SEL))_imp(objcT2,selTransTbl[0]))(objcT2,selTransTbl[0],_cmd));
(objcT3=self->compound,(*_imp(objcT3,selTransTbl[2]))(objcT3,selTransTbl[2]));
return(id)self;
}
extern id  Object;
extern struct _SHARED _Object;
extern struct _SHARED __Object;
extern id  Node;
extern struct _SHARED _Node;
extern struct _SHARED __Node;
static struct _SLT _FunctionBody_clsDispatchTbl[] ={
{(char*)0,(id (*)())0}
};
static struct _SLT _FunctionBody_nstDispatchTbl[] ={
{"compound",(id (*)())i_FunctionBody_compound},
{"datadefs:",(id (*)())i_FunctionBody_datadefs_},
{"compound:",(id (*)())i_FunctionBody_compound_},
{"gen",(id (*)())i_FunctionBody_gen},
{"synth",(id (*)())i_FunctionBody_synth},
{(char*)0,(id (*)())0}
};
id FunctionBody = (id)&_FunctionBody;
id  *OBJCCLASS_FunctionBody(void) { return &FunctionBody; }
struct _SHARED  _FunctionBody = {
  (id)&__FunctionBody,
  (id)&_Node,
  "FunctionBody",
  0,
  sizeof(struct FunctionBody_PRIVATE),
  5,
  _FunctionBody_nstDispatchTbl,
  41,
  &funbody_modDesc,
  0,
  (id)0,
  &FunctionBody,
};
id  OBJCCFUNC_FunctionBody(void) { return (id)&_FunctionBody; }
id  OBJCCSUPER_FunctionBody(void) { return _FunctionBody.clsSuper; }
struct _SHARED __FunctionBody = {
  (id)&__Object,
  (id)&__Node,
  "FunctionBody",
  0,
  sizeof(struct _SHARED),
  0,
  _FunctionBody_clsDispatchTbl,
  34,
  &funbody_modDesc,
  0,
  (id)0,
  0,
};
id  OBJCMFUNC_FunctionBody(void) { return (id)&__FunctionBody; }
id  OBJCMSUPER_FunctionBody(void) { return __FunctionBody.clsSuper; }
static char *_selTransTbl[] ={
"elementsPerform:",
"gen",
"synth",
0
};
struct modDescriptor funbody_modDesc = {
  "funbody",
  "objc2.3.8",
  0L,
  0,
  0,
  &FunctionBody,
  3,
  _selTransTbl,
  0
};
struct modDescriptor *_OBJCBIND_funbody(void)
{
  selTransTbl = _selTransTbl;
  return &funbody_modDesc;
}
int _OBJCPOSTLINK_funbody = 1;


