#line 1 "msgxpr.m"
struct _PRIVATE { struct _PRIVATE *isa; };
typedef struct _PRIVATE *id;
struct _SHARED {
  id isa;
  id clsSuper;
  char *clsName;
  char *clsTypes;
  short clsSizInstance;
  short clsSizDict;
  struct _SLT *clsDispTable;
  long clsStatus;
  struct modDescriptor *clsMod;
  unsigned clsVersion;
  id clsCats;
  id *clsGlbl;
};
extern id  (* _imp(id,char*))();
extern id  (* _impSuper(id,char*))();
extern struct modDescriptor  *_OBJCBIND_msgxpr(void);
static char **selTransTbl;
struct _SLT {char *_cmd;id (*_imp)();};
struct modDescriptor {
  char *modName;
  char *modVersion;
  long modStatus;
  char *modMinSel;
  char *modMaxSel;
  id *modClsLst;
  short modSelRef;
  char **modSelTbl;
  struct methodDescriptor *modMapTbl;
};
extern struct modDescriptor msgxpr_modDesc;

#line 1 "../../util/stdarg.h"
#include <stdarg.h>

#line 1 "../../util/stdlib.h"
#include <stdlib.h>

#line 1 "../../util/assert.h"
#include <assert.h>

#line 1 "../../util/string.h"
#include <string.h>

#line 1 "../../util/stdio.h"
#include <stdio.h>

#line 1 "../../util/stddef.h"
#include <stddef.h>

#line 70 "../../include/objcrt/objcrt.h"
typedef char*SEL;
typedef char*STR;
typedef char BOOL;
typedef FILE*IOD;
typedef id SHR;
#line 79 "../../include/objcrt/objcrt.h"
typedef id(*IMP)();


typedef void(*ARGIMP)(id,SEL,void*);
#line 102 "../../include/objcrt/objcrt.h"
extern BOOL msgFlag;
extern FILE*msgIOD;
extern FILE*dbgIOD;
extern BOOL allocFlag;
extern BOOL dbgFlag;
extern BOOL noCacheFlag;
extern BOOL noNilRcvr;
#line 115 "../../include/objcrt/objcrt.h"
SEL selUid(STR);
STR selName(SEL);
void dbg(char*fmt,...);
void prnstack(FILE*file);
void loadobjc(void*modPtr);
void unloadobjc(void*modPtr);
#line 124 "../../include/objcrt/objcrt.h"
IMP fwdimp(id,SEL,IMP);
IMP fwdimpSuper(id,SEL,IMP);
void fwdmsg(id,SEL,void*,ARGIMP);
id selptrfwd(id,SEL,id,id,id,id);


id idincref(id obj);
id idassign(id*lhs,id rhs);
id iddecref(id obj);

extern id(*_fileIn)(FILE*);
extern BOOL(*_fileOut)(FILE*,id);
extern BOOL(*_storeOn)(STR,id);
extern id(*_readFrom)(STR);
void setfilein(id(*f)(FILE*));
void setfileout(BOOL(*f)(FILE*,id));

extern id(*_showOn)(id,unsigned);

void*OC_Malloc(size_t);
void*OC_MallocAtomic(size_t);
void*OC_Calloc(size_t);
void*OC_Realloc(void*,size_t);
void*OC_Free(void*data);
#line 1 "../../util/string.h"
#include <string.h>

#line 1 "../../util/stdio.h"
#include <stdio.h>

#line 32 "../../include/objpak/ocstring.h"
typedef struct objstr{
int count;
int capacity;
char*ptr;
}*objstr_t;
#line 22 "node.h"
extern FILE*gfile;
extern int inlineno;
extern id infilename;
extern int outlineno;
extern char*outfilename;
extern int exitstatus;

void gc(char c);
void gextc(void);
void gcom(char*cm);
void gvarlist(id c,char*sp,char*iz);
void gcommalist(id c);
void gs(char*str);
void gf(char*fmt,...);
void gl(int no,char*fn);
void g_otbvars(void);
void gstderr(void);
void gnormal(void);

void warn(char*fmt,...);
void warnat(id sym,char*fmt,...);
void fatal(char*fmt,...);
void fatalat(id sym,char*fmt,...);
#line 22 "expr.h"
extern id e_nil;
extern id e_self;
extern id e_cmd;
extern id e_super;
extern id e_aFiler;
extern id e_ft_id;
#line 22 "compstmt.h"
extern id curcompound;
extern id curloopcompound;
#line 22 "symbol.h"
extern id s_void;
extern id s_char;
extern id s_bool;
extern id s_int;
extern id s_long;
extern id s_double;
extern id s_str;
extern id s_sel;
extern id s_newblock;
extern id s_main;
extern id s_objcmain;
extern id s_id;
extern id s_nil;
extern id s_self;
extern id s_cmd;
extern id s_super;
extern id s_type;
extern id s_aFiler;
extern id s_fileIn;
extern id s_fileOut;
extern id s_fileInIdsFrom;
extern id s_fileOutIdsFor;
extern id s_returnval;
extern id s_returnflag;
extern id s_increfs;
extern id s_decrefs;
extern id s_idincref;
extern id s_iddecref;

BOOL istypeword(id sym);
BOOL isbuiltinfun(id sym);
int pragmatoggle(char*s);
void definebuiltintype(char*s);
void definebuiltinfun(char*s);
void definebuiltinvar(char*s);
#line 22 "def.h"
extern id curdef;
#line 22 "classdef.h"
extern id curclassdef;
extern id curstruct;
#line 22 "type.h"
extern id t_unknown;
extern id t_void;
extern id t_char;
extern id t_bool;
extern id t_int;
extern id t_long;
extern id t_double;
extern id t_str;
extern id t_sel;
extern id t_id;
#line 22 "trlunit.h"
extern id trlunit;
#line 22 "options.h"
void defoptions(void);

extern int o_gnu;
extern int o_refcnt;
extern int o_ppi;
extern int o_watcom;
extern int o_ibmvac;
extern int o_msdos;
extern int o_enableasm;
extern int o_nolinetags;
extern int o_buffered;
extern int o_quiet;
extern int o_outputcode;
extern int o_version;
extern int o_otb;
extern int o_llkeyw;
extern int o_comments;
extern int o_seltranslation;
extern int o_categories;
extern int o_blocks;
extern int o_fwd;
extern int o_selptr;
extern int o_cache;
extern int o_filer;
extern int o_selfassign;
extern char*o_bind;
extern int o_refbind;
extern int o_inlinecache;
extern int o_cplus;
extern int o_gencode;
extern int o_st80;
extern int o_selfassign;
extern int o_nilrcvr;
extern int o_shareddata;
extern int o_oneperfile;
extern int o_cvars;
extern int o_warnlex;
extern int o_warnfwd;
extern int o_warnsuggest;
extern int o_warnintvar;
extern int o_warnclasstype;
extern int o_warntypeconflict;
extern int o_warnundefined;
extern int o_warnlocalnst;
extern int o_warnnotfound;
extern int o_warnmissingmethods;
extern int o_postlink;
extern char*o_infile;
extern char*o_outfile;
extern char*o_srcfilename;
extern char*o_initcall;
extern char*o_tagformat;
extern char*o_mainfun;
extern char*o_pathsep;
extern int o_debuginfo;
extern int o_checkbind;
extern int o_linemax;
extern int o_structassign;
#line 22 "msgxpr.h"
struct MesgExpr_PRIVATE {

#line 42 "../../include/objcrt/Object.h"
id isa;
#line 46 "../../include/objcrt/Object.h"
unsigned short attr;
unsigned short objID;
#line 31 "expr.h"
id type;
#line 24 "msgxpr.h"
id msg;
id sel;
id rcvr;
BOOL supermsg;
BOOL infactory;
BOOL indispatchfun;
BOOL methodfound;
id method;
id classdef;
id tmpvar;
id refvar;
id icache;
char*fwdname;
char*dispname;
char*argstructname;};

#line 22 "msgxpr.h"
extern id  MesgExpr;

#line 22 "msgxpr.h"
extern struct _SHARED _MesgExpr;
extern struct _SHARED __MesgExpr;


#line 48 "msgxpr.m"
static BOOL i_MesgExpr_canforward(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT0;


return self->method!=(id)0&&(objcT0=self->method,(*(BOOL(*)(id,SEL))_imp(objcT0,selTransTbl[0]))(objcT0,selTransTbl[0]));

}

static unsigned i_MesgExpr_hash(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT1;

#line 59 "msgxpr.m"
id a;

if((a=(objcT1=(id)self,(*_imp(objcT1,selTransTbl[1]))(objcT1,selTransTbl[1])))){
id objcT2;

#line 62 "msgxpr.m"
return(objcT2=a,(*(unsigned(*)(id,SEL))_imp(objcT2,selTransTbl[2]))(objcT2,selTransTbl[2]));
}else{
id objcT3;

#line 64 "msgxpr.m"
return(objcT3=self->msg,(*(unsigned(*)(id,SEL))_imp(objcT3,selTransTbl[3]))(objcT3,selTransTbl[3]));
}
}

static BOOL i_MesgExpr_isEqual_(struct MesgExpr_PRIVATE *self,SEL _cmd,id that)
{
if((id)self==that){
return(BOOL)1;
}else{
id objcT4,objcT5,objcT6,objcT7,objcT8;

#line 73 "msgxpr.m"
id a=(objcT4=(id)self,(*_imp(objcT4,selTransTbl[1]))(objcT4,selTransTbl[1]));
id b=(objcT5=that,(*_imp(objcT5,selTransTbl[1]))(objcT5,selTransTbl[1]));

if( !a)
a=(objcT6=(id)self,(*_imp(objcT6,selTransTbl[4]))(objcT6,selTransTbl[4]));
if( !b)
b=(objcT7=that,(*_imp(objcT7,selTransTbl[4]))(objcT7,selTransTbl[4]));
return(objcT8=a,(*(BOOL(*)(id,SEL,id))_imp(objcT8,selTransTbl[5]))(objcT8,selTransTbl[5],b));
}
}

static id i_MesgExpr_receiver_(struct MesgExpr_PRIVATE *self,SEL _cmd,id aRcvr)
{self->
rcvr=aRcvr;
return(id)self;
}

static id i_MesgExpr_msg_(struct MesgExpr_PRIVATE *self,SEL _cmd,id m)
{self->
msg=m;(
void)0;
return(id)self;
}

static id i_MesgExpr_tmpvar(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT9;

#line 99 "msgxpr.m"
if(self->tmpvar)
return self->tmpvar;

return self->tmpvar=(objcT9=trlunit,(*_imp(objcT9,selTransTbl[6]))(objcT9,selTransTbl[6]));
}

#line 38 "../../include/objpak/ocstring.h"
extern id  String;

#line 105 "msgxpr.m"
static id i_MesgExpr_icache(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT10,objcT11;

#line 107 "msgxpr.m"
if(self->icache)
return self->icache;
return self->icache=(objcT10=String,(*(id(*)(id,SEL,STR,...))_imp(objcT10,selTransTbl[7]))(objcT10,selTransTbl[7],"objcIC%i",(objcT11=trlunit,(*(int(*)(id,SEL))_imp(objcT11,selTransTbl[8]))(objcT11,selTransTbl[8]))));
}

static id i_MesgExpr_msg(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
return self->msg;
}

static id i_MesgExpr_method(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
if(self->methodfound){
return self->method;
}else{
id objcT12,objcT13;
self->
#line 122 "msgxpr.m"
methodfound++;self->
method=(objcT12=trlunit,(*_imp(objcT12,selTransTbl[9]))(objcT12,selTransTbl[9],(objcT13=(id)self,(*_imp(objcT13,selTransTbl[10]))(objcT13,selTransTbl[10]))));
if( !self->method&&o_warnundefined){
id objcT14;

#line 125 "msgxpr.m"
warnat(self->msg,"argument types for '%s' default to 'id'",(objcT14=self->sel,(*(STR(*)(id,SEL))_imp(objcT14,selTransTbl[11]))(objcT14,selTransTbl[11])));
}else{
id objcT15,objcT16;

#line 127 "msgxpr.m"
if((objcT15=self->method,(*(BOOL(*)(id,SEL))_imp(objcT15,selTransTbl[12]))(objcT15,selTransTbl[12])))
(objcT16=self->msg,(*_imp(objcT16,selTransTbl[13]))(objcT16,selTransTbl[13]));
}
return self->method;
}
}

static id i_MesgExpr_indispatchfun_(struct MesgExpr_PRIVATE *self,SEL _cmd,BOOL f)
{self->
indispatchfun=f;
return(id)self;
}

static BOOL i_MesgExpr_varargs(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT17,objcT18;

#line 142 "msgxpr.m"
return(objcT17=(objcT18=(id)self,(*_imp(objcT18,selTransTbl[1]))(objcT18,selTransTbl[1])),(*(BOOL(*)(id,SEL))_imp(objcT17,selTransTbl[12]))(objcT17,selTransTbl[12]));
}

static id i_MesgExpr_selector(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT19;

#line 147 "msgxpr.m"
if(self->sel)
return self->sel;self->
sel=(objcT19=self->msg,(*_imp(objcT19,selTransTbl[10]))(objcT19,selTransTbl[10]));
return self->sel;
}

static id i_MesgExpr_typesynth(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT20,objcT21;

#line 155 "msgxpr.m"
if((objcT20=(id)self,(*_imp(objcT20,selTransTbl[1]))(objcT20,selTransTbl[1])))self->
type=(objcT21=self->method,(*_imp(objcT21,selTransTbl[14]))(objcT21,selTransTbl[14]));
if( !self->type)self->
type=t_id;
return(id)self;
}

static id i_MesgExpr_synth(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT22,objcT23,objcT24,objcT33,objcT34;
id objcT35,objcT36;
self->
#line 165 "msgxpr.m"
method=(objcT22=(id)self,(*_imp(objcT22,selTransTbl[1]))(objcT22,selTransTbl[1]));
if((objcT23=(id)self,(*(BOOL(*)(id,SEL))_imp(objcT23,selTransTbl[12]))(objcT23,selTransTbl[12])))
(objcT24=self->msg,(*_imp(objcT24,selTransTbl[15]))(objcT24,selTransTbl[15]));

if(curcompound){
id objcT25,objcT26,objcT29,objcT30,objcT31;
id objcT32;

#line 170 "msgxpr.m"
BOOL inm=(curdef&&(objcT25=curdef,(*(BOOL(*)(id,SEL))_imp(objcT25,selTransTbl[16]))(objcT25,selTransTbl[16])));


if(inm&&(objcT26=self->rcvr,(*(BOOL(*)(id,SEL))_imp(objcT26,selTransTbl[17]))(objcT26,selTransTbl[17]))){
id objcT27,objcT28;
self->
#line 174 "msgxpr.m"
supermsg= !strcmp((objcT27=self->rcvr,(*(STR(*)(id,SEL))_imp(objcT27,selTransTbl[11]))(objcT27,selTransTbl[11])),"super");self->
infactory=(objcT28=curdef,(*(BOOL(*)(id,SEL))_imp(objcT28,selTransTbl[18]))(objcT28,selTransTbl[18]));self->
classdef=curclassdef;
if(self->supermsg)self->
rcvr=(id)0;
}
(objcT29=curcompound,(*_imp(objcT29,selTransTbl[19]))(objcT29,selTransTbl[19],(objcT30=(id)self,(*_imp(objcT30,selTransTbl[20]))(objcT30,selTransTbl[20]))));
if(o_inlinecache)
(objcT31=curcompound,(*_imp(objcT31,selTransTbl[21]))(objcT31,selTransTbl[21],(objcT32=(id)self,(*_imp(objcT32,selTransTbl[22]))(objcT32,selTransTbl[22]))));
}else{
fatalat(self->msg,"message expression outside compound statement");
}

if(self->rcvr)
(objcT33=self->rcvr,(*_imp(objcT33,selTransTbl[23]))(objcT33,selTransTbl[23]));
(objcT34=self->msg,(*_imp(objcT34,selTransTbl[23]))(objcT34,selTransTbl[23]));

if(o_refcnt&&(objcT35=(objcT36=(id)self,(*_imp(objcT36,selTransTbl[24]))(objcT36,selTransTbl[24])),(*(BOOL(*)(id,SEL))_imp(objcT35,selTransTbl[25]))(objcT35,selTransTbl[25]))){
id objcT37,objcT38,objcT39;
self->
#line 192 "msgxpr.m"
refvar=(objcT37=trlunit,(*_imp(objcT37,selTransTbl[6]))(objcT37,selTransTbl[6]));
(objcT38=curcompound,(*_imp(objcT38,selTransTbl[19]))(objcT38,selTransTbl[19],self->refvar));
(objcT39=curcompound,(*_imp(objcT39,selTransTbl[26]))(objcT39,selTransTbl[26],self->refvar));
}
return(id)self;
}

static id i_MesgExpr_assignrcvr(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT40,objcT41,objcT42;

#line 201 "msgxpr.m"
id t=(objcT40=(id)self,(*_imp(objcT40,selTransTbl[20]))(objcT40,selTransTbl[20]));

gf("%s=",(objcT41=t,(*(STR(*)(id,SEL))_imp(objcT41,selTransTbl[11]))(objcT41,selTransTbl[11])));
(objcT42=self->rcvr,(*_imp(objcT42,selTransTbl[27]))(objcT42,selTransTbl[27]));
return(id)self;
}

static id i_MesgExpr_assignsuper(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT43,objcT44,objcT45,objcT46;

#line 210 "msgxpr.m"
id t=(objcT43=(id)self,(*_imp(objcT43,selTransTbl[20]))(objcT43,selTransTbl[20]));

gf("%s=",(objcT44=t,(*(STR(*)(id,SEL))_imp(objcT44,selTransTbl[11]))(objcT44,selTransTbl[11])));(
void)0;
return(self->infactory)?(objcT45=self->classdef,(*_imp(objcT45,selTransTbl[28]))(objcT45,selTransTbl[28])):(objcT46=self->classdef,(*_imp(objcT46,selTransTbl[29]))(objcT46,selTransTbl[29]));
}

static id i_MesgExpr_genimpcall_(struct MesgExpr_PRIVATE *self,SEL _cmd,BOOL tosuper)
{
char*messenger;

if( !o_fwd){
id objcT47;

#line 222 "msgxpr.m"
messenger=(tosuper)?"_impSuper":"_imp";
gf("%s(%s,",messenger,(objcT47=self->tmpvar,(*(STR(*)(id,SEL))_imp(objcT47,selTransTbl[11]))(objcT47,selTransTbl[11])));
if(self->indispatchfun){
gs("_cmd");
}else{
id objcT48,objcT49;

#line 227 "msgxpr.m"
(objcT48=(objcT49=(id)self,(*_imp(objcT49,selTransTbl[10]))(objcT49,selTransTbl[10])),(*_imp(objcT48,selTransTbl[27]))(objcT48,selTransTbl[27]));
}
gc(')');
}else{
id objcT50,objcT53;

#line 231 "msgxpr.m"
messenger=(tosuper)?"fwdimpSuper":"fwdimp";
gf("%s(%s,",messenger,(objcT50=self->tmpvar,(*(STR(*)(id,SEL))_imp(objcT50,selTransTbl[11]))(objcT50,selTransTbl[11])));
if(self->indispatchfun){
gs("_cmd");
}else{
id objcT51,objcT52;

#line 236 "msgxpr.m"
(objcT51=(objcT52=(id)self,(*_imp(objcT52,selTransTbl[10]))(objcT52,selTransTbl[10])),(*_imp(objcT51,selTransTbl[27]))(objcT51,selTransTbl[27]));
}
gc(',');
if((objcT53=(id)self,(*(BOOL(*)(id,SEL))_imp(objcT53,selTransTbl[0]))(objcT53,selTransTbl[0]))){
id objcT54;

#line 240 "msgxpr.m"
if((objcT54=self->method,(*(BOOL(*)(id,SEL))_imp(objcT54,selTransTbl[30]))(objcT54,selTransTbl[30]))){
gs("selptrfwd");
}else{
id objcT55;

#line 243 "msgxpr.m"
gf("fwdTransTbl[%i]",(objcT55=trlunit,(*(int(*)(id,SEL,id))_imp(objcT55,selTransTbl[31]))(objcT55,selTransTbl[31],(id)self)));
}
}else{
gs((o_cplus)?"(id(*)(...))0":"(id(*)())0");
if(o_warnfwd){
id objcT56;

#line 248 "msgxpr.m"
char*fmt;

if(self->method){
fmt="forwarding of '%s' messages not supported";
}else{
fmt="cannot forward '%s'. no such method found.";
}
warnat(self->msg,fmt,(objcT56=self->sel,(*(STR(*)(id,SEL))_imp(objcT56,selTransTbl[11]))(objcT56,selTransTbl[11])));
}
}
gc(')');
}

return(id)self;
}

static id i_MesgExpr_geninlinecall_(struct MesgExpr_PRIVATE *self,SEL _cmd,BOOL tosuper)
{
id objcT57,objcT58,objcT59;

#line 266 "msgxpr.m"
char*fmt;
char*tvar=(objcT57=self->tmpvar,(*(STR(*)(id,SEL))_imp(objcT57,selTransTbl[11]))(objcT57,selTransTbl[11]));
char*cache=(objcT58=self->icache,(*(STR(*)(id,SEL))_imp(objcT58,selTransTbl[11]))(objcT58,selTransTbl[11]));

gf("(%s)?(",tvar);
gc('(');
if( !o_otb){
fmt=(tosuper)?"%s":"%s->isa";
}else{
fmt=(tosuper)?"%s":"%s->ptr->isa";
}
gf(fmt,tvar);
gf("==%s.cls)?%s.imp:",cache,cache);
gc('(');
gf("%s.cls=",cache);
gf(fmt,tvar);
gf(",%s.imp=",cache);
(objcT59=(id)self,(*(id(*)(id,SEL,BOOL))_imp(objcT59,selTransTbl[32]))(objcT59,selTransTbl[32],tosuper));
gc(')');
gs("):_nilHandler");
return(id)self;
}



static id i_MesgExpr_gencall_(struct MesgExpr_PRIVATE *self,SEL _cmd,BOOL tosuper)
{
id objcT60;

#line 293 "msgxpr.m"
gs("(*");
if(self->method&&(objcT60=self->method,(*(BOOL(*)(id,SEL))_imp(objcT60,selTransTbl[33]))(objcT60,selTransTbl[33]))){
id objcT61;

#line 295 "msgxpr.m"
gc('(');
(objcT61=self->method,(*_imp(objcT61,selTransTbl[34]))(objcT61,selTransTbl[34]));
gc(')');
}
if(o_inlinecache&& !self->indispatchfun){
id objcT62;

#line 300 "msgxpr.m"
gc('(');
(objcT62=(id)self,(*(id(*)(id,SEL,BOOL))_imp(objcT62,selTransTbl[35]))(objcT62,selTransTbl[35],tosuper));
gc(')');
}else{
id objcT63;

#line 304 "msgxpr.m"
(objcT63=(id)self,(*(id(*)(id,SEL,BOOL))_imp(objcT63,selTransTbl[32]))(objcT63,selTransTbl[32],tosuper));
}
gc(')');
return(id)self;
}

static id i_MesgExpr_genmsgargs_(struct MesgExpr_PRIVATE *self,SEL _cmd,BOOL tosuper)
{
if(tosuper){
id objcT64;

#line 313 "msgxpr.m"
gs("(id)");
(objcT64=e_self,(*_imp(objcT64,selTransTbl[36]))(objcT64,selTransTbl[36]));
}else{
id objcT65;

#line 316 "msgxpr.m"
gs((objcT65=self->tmpvar,(*(STR(*)(id,SEL))_imp(objcT65,selTransTbl[11]))(objcT65,selTransTbl[11])));
}

gc(',');
if(self->indispatchfun){
gs("_cmd");
}else{
id objcT66,objcT67;

#line 323 "msgxpr.m"
(objcT66=(objcT67=(id)self,(*_imp(objcT67,selTransTbl[10]))(objcT67,selTransTbl[10])),(*_imp(objcT66,selTransTbl[27]))(objcT66,selTransTbl[27]));
}

if(self->indispatchfun){
id objcT68;

#line 327 "msgxpr.m"
(objcT68=self->method,(*_imp(objcT68,selTransTbl[37]))(objcT68,selTransTbl[37]));
}else{
id objcT69;

#line 329 "msgxpr.m"
(objcT69=self->msg,(*_imp(objcT69,selTransTbl[38]))(objcT69,selTransTbl[38]));
}

return(id)self;
}

static id i_MesgExpr_genmsg_(struct MesgExpr_PRIVATE *self,SEL _cmd,BOOL insuper)
{
id objcT70,objcT71;

#line 337 "msgxpr.m"
(objcT70=(id)self,(*(id(*)(id,SEL,BOOL))_imp(objcT70,selTransTbl[39]))(objcT70,selTransTbl[39],insuper));
gc('(');
(objcT71=(id)self,(*(id(*)(id,SEL,BOOL))_imp(objcT71,selTransTbl[40]))(objcT71,selTransTbl[40],insuper));
gc(')');
return(id)self;
}

static id i_MesgExpr_genmsg(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT72,objcT73;

#line 346 "msgxpr.m"
gc('(');
(objcT72=(id)self,(*_imp(objcT72,selTransTbl[41]))(objcT72,selTransTbl[41]));
gc(',');
(objcT73=(id)self,(*(id(*)(id,SEL,BOOL))_imp(objcT73,selTransTbl[42]))(objcT73,selTransTbl[42],(BOOL)0));
gc(')');
return(id)self;
}

static id i_MesgExpr_gensupermsg(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT74,objcT75;

#line 356 "msgxpr.m"
gc('(');
(objcT74=(id)self,(*_imp(objcT74,selTransTbl[43]))(objcT74,selTransTbl[43]));
gc(',');
(objcT75=(id)self,(*(id(*)(id,SEL,BOOL))_imp(objcT75,selTransTbl[42]))(objcT75,selTransTbl[42],(BOOL)1));
gc(')');
return(id)self;
}

static int i_MesgExpr_lineno(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT76;

#line 366 "msgxpr.m"
return(objcT76=self->msg,(*(int(*)(id,SEL))_imp(objcT76,selTransTbl[44]))(objcT76,selTransTbl[44]));
}

static id i_MesgExpr_filename(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT77;

#line 371 "msgxpr.m"
return(objcT77=self->msg,(*_imp(objcT77,selTransTbl[45]))(objcT77,selTransTbl[45]));
}

static id i_MesgExpr_gen(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT78,objcT79,objcT80,objcT82,objcT83;

#line 376 "msgxpr.m"
gl((objcT78=self->msg,(*(int(*)(id,SEL))_imp(objcT78,selTransTbl[44]))(objcT78,selTransTbl[44])),(objcT79=(objcT80=self->msg,(*_imp(objcT80,selTransTbl[45]))(objcT80,selTransTbl[45])),(*(STR(*)(id,SEL))_imp(objcT79,selTransTbl[11]))(objcT79,selTransTbl[11])));
if(self->refvar){
id objcT81;

#line 378 "msgxpr.m"
gc('(');
gs((objcT81=self->refvar,(*(STR(*)(id,SEL))_imp(objcT81,selTransTbl[11]))(objcT81,selTransTbl[11])));
gc('=');
}(self->
supermsg)?(objcT82=(id)self,(*_imp(objcT82,selTransTbl[46]))(objcT82,selTransTbl[46])):(objcT83=(id)self,(*_imp(objcT83,selTransTbl[47]))(objcT83,selTransTbl[47]));
if(self->refvar)gc(')');
return(id)self;
}

#line 58 "symbol.h"
extern id  Symbol;

#line 387 "msgxpr.m"
static char*i_MesgExpr_fwdname(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT84,objcT85,objcT86,objcT87;
(
#line 389 "msgxpr.m"
void)0;
if(self->fwdname)
return self->fwdname;self->
fwdname=(objcT84=(objcT85=(objcT86=Symbol,(*(id(*)(id,SEL,STR,...))_imp(objcT86,selTransTbl[7]))(objcT86,selTransTbl[7],"%s_fwd",(objcT87=self->sel,(*(STR(*)(id,SEL))_imp(objcT87,selTransTbl[11]))(objcT87,selTransTbl[11])))),(*_imp(objcT85,selTransTbl[48]))(objcT85,selTransTbl[48])),(*(STR(*)(id,SEL))_imp(objcT84,selTransTbl[49]))(objcT84,selTransTbl[49]));
return self->fwdname;
}

static char*i_MesgExpr_dispname(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT88,objcT89,objcT90,objcT91;
(
#line 398 "msgxpr.m"
void)0;
if(self->dispname)
return self->dispname;self->
dispname=(objcT88=(objcT89=(objcT90=Symbol,(*(id(*)(id,SEL,STR,...))_imp(objcT90,selTransTbl[7]))(objcT90,selTransTbl[7],"%s_disp",(objcT91=self->sel,(*(STR(*)(id,SEL))_imp(objcT91,selTransTbl[11]))(objcT91,selTransTbl[11])))),(*_imp(objcT89,selTransTbl[48]))(objcT89,selTransTbl[48])),(*(STR(*)(id,SEL))_imp(objcT88,selTransTbl[49]))(objcT88,selTransTbl[49]));
return self->dispname;
}

static char*i_MesgExpr_argstructname(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT92,objcT93,objcT94,objcT95;
(
#line 407 "msgxpr.m"
void)0;
if(self->argstructname)
return self->argstructname;self->
argstructname=(objcT92=(objcT93=(objcT94=Symbol,(*(id(*)(id,SEL,STR,...))_imp(objcT94,selTransTbl[7]))(objcT94,selTransTbl[7],"%s_args",(objcT95=self->sel,(*(STR(*)(id,SEL))_imp(objcT95,selTransTbl[11]))(objcT95,selTransTbl[11])))),(*_imp(objcT93,selTransTbl[48]))(objcT93,selTransTbl[48])),(*(STR(*)(id,SEL))_imp(objcT92,selTransTbl[49]))(objcT92,selTransTbl[49]));
return self->argstructname;
}

static id i_MesgExpr_genargstruct(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT96,objcT97;
(
#line 416 "msgxpr.m"
void)0;
gf("struct %s {\n",(objcT96=(id)self,(*(char*(*)(id,SEL))_imp(objcT96,selTransTbl[50]))(objcT96,selTransTbl[50])));
(objcT97=self->method,(*_imp(objcT97,selTransTbl[51]))(objcT97,selTransTbl[51]));
gs("};\n");
return(id)self;
}

static id i_MesgExpr_xgendispfun(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT98,objcT99,objcT100,objcT101,objcT102;

#line 425 "msgxpr.m"
id rt;(

void)0;
gf("static void %s(id self,SEL _cmd",(objcT98=(id)self,(*(char*(*)(id,SEL))_imp(objcT98,selTransTbl[52]))(objcT98,selTransTbl[52])));
gf(",struct %s *args)\n",(objcT99=(id)self,(*(char*(*)(id,SEL))_imp(objcT99,selTransTbl[50]))(objcT99,selTransTbl[50])));
gs("{\n");
if((rt=(objcT100=self->method,(*_imp(objcT100,selTransTbl[14]))(objcT100,selTransTbl[14])))==(id)0|| !(objcT101=rt,(*(BOOL(*)(id,SEL))_imp(objcT101,selTransTbl[53]))(objcT101,selTransTbl[53]))){
gs("args->_retval = ");
}
(objcT102=(id)self,(*(id(*)(id,SEL,BOOL))_imp(objcT102,selTransTbl[42]))(objcT102,selTransTbl[42],(BOOL)0));
gs(";\n");
gs("}\n");
return(id)self;
}

static id i_MesgExpr_gendispfun(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT103;
(
#line 442 "msgxpr.m"
void)0;self->
rcvr=e_self;self->
tmpvar=e_self;self->
indispatchfun++;
return(objcT103=(id)self,(*_imp(objcT103,selTransTbl[54]))(objcT103,selTransTbl[54]));
}

static id i_MesgExpr_gendispargsintostruct(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT104;

#line 451 "msgxpr.m"
(objcT104=self->method,(*_imp(objcT104,selTransTbl[55]))(objcT104,selTransTbl[55]));
return(id)self;
}

static id i_MesgExpr_genfwdstub(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT105,objcT106,objcT107,objcT108,objcT109;
id objcT110,objcT111,objcT112;

#line 457 "msgxpr.m"
id rt;(

void)0;
gs("static ");
(objcT105=self->method,(*_imp(objcT105,selTransTbl[56]))(objcT105,selTransTbl[56]));
gf(" %s(id self,SEL _cmd",(objcT106=(id)self,(*(char*(*)(id,SEL))_imp(objcT106,selTransTbl[57]))(objcT106,selTransTbl[57])));
(objcT107=self->method,(*_imp(objcT107,selTransTbl[58]))(objcT107,selTransTbl[58]));
gs(")\n");
gs("{\n");
gf("struct %s args;\n",(objcT108=(id)self,(*(char*(*)(id,SEL))_imp(objcT108,selTransTbl[50]))(objcT108,selTransTbl[50])));
(objcT109=(id)self,(*_imp(objcT109,selTransTbl[55]))(objcT109,selTransTbl[55]));
gf("fwdmsg(self,_cmd,&args,(ARGIMP)%s);\n",(objcT110=(id)self,(*(char*(*)(id,SEL))_imp(objcT110,selTransTbl[52]))(objcT110,selTransTbl[52])));
if((rt=(objcT111=self->method,(*_imp(objcT111,selTransTbl[14]))(objcT111,selTransTbl[14])))==(id)0|| !(objcT112=rt,(*(BOOL(*)(id,SEL))_imp(objcT112,selTransTbl[53]))(objcT112,selTransTbl[53]))){
gs("return args._retval;\n");
}
gs("}\n");
return(id)self;
}

static id i_MesgExpr_st80(struct MesgExpr_PRIVATE *self,SEL _cmd)
{
id objcT113,objcT114;

#line 478 "msgxpr.m"
gc('(');
(objcT113=self->rcvr,(*_imp(objcT113,selTransTbl[59]))(objcT113,selTransTbl[59]));
(objcT114=self->msg,(*_imp(objcT114,selTransTbl[59]))(objcT114,selTransTbl[59]));
gc(')');
return(id)self;
}
extern id  Object;
extern struct _SHARED _Object;
extern struct _SHARED __Object;
extern id  Expr;
extern struct _SHARED _Expr;
extern struct _SHARED __Expr;
static struct _SLT _MesgExpr_clsDispatchTbl[] ={
{(char*)0,(id (*)())0}
};
static struct _SLT _MesgExpr_nstDispatchTbl[] ={
{"canforward",(id (*)())i_MesgExpr_canforward},
{"hash",(id (*)())i_MesgExpr_hash},
{"isEqual:",(id (*)())i_MesgExpr_isEqual_},
{"receiver:",(id (*)())i_MesgExpr_receiver_},
{"msg:",(id (*)())i_MesgExpr_msg_},
{"tmpvar",(id (*)())i_MesgExpr_tmpvar},
{"icache",(id (*)())i_MesgExpr_icache},
{"msg",(id (*)())i_MesgExpr_msg},
{"method",(id (*)())i_MesgExpr_method},
{"indispatchfun:",(id (*)())i_MesgExpr_indispatchfun_},
{"varargs",(id (*)())i_MesgExpr_varargs},
{"selector",(id (*)())i_MesgExpr_selector},
{"typesynth",(id (*)())i_MesgExpr_typesynth},
{"synth",(id (*)())i_MesgExpr_synth},
{"assignrcvr",(id (*)())i_MesgExpr_assignrcvr},
{"assignsuper",(id (*)())i_MesgExpr_assignsuper},
{"genimpcall:",(id (*)())i_MesgExpr_genimpcall_},
{"geninlinecall:",(id (*)())i_MesgExpr_geninlinecall_},
{"gencall:",(id (*)())i_MesgExpr_gencall_},
{"genmsgargs:",(id (*)())i_MesgExpr_genmsgargs_},
{"genmsg:",(id (*)())i_MesgExpr_genmsg_},
{"genmsg",(id (*)())i_MesgExpr_genmsg},
{"gensupermsg",(id (*)())i_MesgExpr_gensupermsg},
{"lineno",(id (*)())i_MesgExpr_lineno},
{"filename",(id (*)())i_MesgExpr_filename},
{"gen",(id (*)())i_MesgExpr_gen},
{"fwdname",(id (*)())i_MesgExpr_fwdname},
{"dispname",(id (*)())i_MesgExpr_dispname},
{"argstructname",(id (*)())i_MesgExpr_argstructname},
{"genargstruct",(id (*)())i_MesgExpr_genargstruct},
{"xgendispfun",(id (*)())i_MesgExpr_xgendispfun},
{"gendispfun",(id (*)())i_MesgExpr_gendispfun},
{"gendispargsintostruct",(id (*)())i_MesgExpr_gendispargsintostruct},
{"genfwdstub",(id (*)())i_MesgExpr_genfwdstub},
{"st80",(id (*)())i_MesgExpr_st80},
{(char*)0,(id (*)())0}
};
id MesgExpr = (id)&_MesgExpr;
id  *OBJCCLASS_MesgExpr(void) { return &MesgExpr; }
struct _SHARED  _MesgExpr = {
  (id)&__MesgExpr,
  (id)&_Expr,
  "MesgExpr",
  0,
  sizeof(struct MesgExpr_PRIVATE),
  35,
  _MesgExpr_nstDispatchTbl,
  41,
  &msgxpr_modDesc,
  0,
  (id)0,
  &MesgExpr,
};
id  OBJCCFUNC_MesgExpr(void) { return (id)&_MesgExpr; }
id  OBJCCSUPER_MesgExpr(void) { return _MesgExpr.clsSuper; }
struct _SHARED __MesgExpr = {
  (id)&__Object,
  (id)&__Expr,
  "MesgExpr",
  0,
  sizeof(struct _SHARED),
  0,
  _MesgExpr_clsDispatchTbl,
  34,
  &msgxpr_modDesc,
  0,
  (id)0,
  0,
};
id  OBJCMFUNC_MesgExpr(void) { return (id)&__MesgExpr; }
id  OBJCMSUPER_MesgExpr(void) { return __MesgExpr.clsSuper; }
static char *_selTransTbl[] ={
"canforward",
"method",
"typehash",
"hash",
"msg",
"typeEqual:",
"gettmpvar",
"sprintf:",
"icachecount",
"lookupmethod:",
"selector",
"str",
"varargs",
"cvtcommalist",
"restype",
"warnforwithmethod",
"ismethdef",
"isidentexpr",
"factory",
"addtmpvar:",
"tmpvar",
"addicache:",
"icache",
"synth",
"type",
"isid",
"adddecref:",
"gen",
"genmetasuper",
"gensuper",
"isselptr",
"fwdoffset:",
"genimpcall:",
"needscast",
"gencast",
"geninlinecall:",
"sgen",
"gendispargs",
"genmsgargs",
"gencall:",
"genmsgargs:",
"assignrcvr",
"genmsg:",
"assignsuper",
"lineno",
"filename",
"gensupermsg",
"genmsg",
"toscores",
"strCopy",
"argstructname",
"genargstruct",
"dispname",
"isvoid",
"xgendispfun",
"gendispargsintostruct",
"genrestype",
"fwdname",
"genparmlist",
"st80",
0
};
struct modDescriptor msgxpr_modDesc = {
  "msgxpr",
  "objc2.3.8",
  0L,
  0,
  0,
  &MesgExpr,
  60,
  _selTransTbl,
  0
};
struct modDescriptor *_OBJCBIND_msgxpr(void)
{
  selTransTbl = _selTransTbl;
  return &msgxpr_modDesc;
}
int _OBJCPOSTLINK_msgxpr = 1;


